#include <iostream>
#include "SDL/SDL.h"
#include "SDL/SDL_opengl.h"
#include "FreeImage.h"
#include <math.h>       /* sin */
#include "FreeImage.h"
#include <map>
#include <unistd.h>
#define _USE_MATH_DEFINES
#define FPS 30
#include <time.h>
#define PI 3.14159265
using namespace std;

///ESTRUCTURAS///
///ALMACENADO DE VERTICES///
struct vertice{
    float x;
    float y;
    float z;
};
std::map<int, vertice> vertices;

///ALMACENADO DE CARAS TRIANGULARES ///
struct triangulos{
    int x;
    int normalx;
    float colorx;
    int y;
    int normaly;
    float colory;
    int z;
    int normalz;
    float colorz;
    bool rueda1;
    bool rueda2;
    bool manubrio;
};
std::map<int, triangulos> carastri;

///ALMACENADO DE CARAS DE CUADRADOS///
struct cuadrados{
    int x;
    int normalx;
    float colorx;
    int y;
    int normaly;
    float colory;
    int z;
    int normalz;
    float colorz;
    int w;
    int normalw;
};
std::map<int,cuadrados> carascu;

///ALMACENADO DE NORMALES///
struct normal{
    int x;
    int y;
    int z;

};
std::map<int,normal> normales;


///VARIABLES GLOBALES///
char ch='1';
bool wireframe = false;
bool textures = true;
bool luz = true;
bool acelerando = false;
int gamespeed = 1;
GLuint auxcuad, auxtri, auxruedas1, auxruedas2, auxman, auxt1, auxt2, canio;
float angulo=0;
float ruedagiro1 = 0.0;
float ruedagiro2 = 0.0;
float panio=0;
GLuint textur[8];
float x,y,z;


///FUNCIONES Y PROCEDIMIENTOS AUXILIARES///

void loadVerticesMoto(char *fname){
    FILE *fp;
    int pos1 = 1;
    int pos2 = 1;
    int pos3 = 1;
    int pos4 = 1;
    int read2, read1;
    auxman = glGenLists(1);
    auxcuad=glGenLists(1);
    auxtri=glGenLists(1);
    auxruedas1 = glGenLists(1);
    auxruedas2 = glGenLists(1);
    canio = glGenLists(1);


    float x1, x2, x3, y1, y2, y3, z1, z2, z3, w1, w2, w3;
    GLfloat x11, x12, x13;
    char ch1, ch2;

    fp=fopen(fname,"r");
    if (!fp){
        printf("can't open file %s\n", fname);
        exit(1);
    }
        while(!(feof(fp))){
            read2=fscanf(fp,"%c  %f %f %f",&ch2,&x11,&x12,&x13);
            if(read2==4&&ch2=='v'){
                vertice aux;
                aux.x = x11;
                aux.y = x12;
                aux.z = x13;
                vertices.insert(std::pair<int, vertice>(pos1, aux)) ;
                pos1++;
            }
            if(read2==4&&ch2=='n'){
                normal aux1;
                aux1.x = x11;
                aux1.y = x12;
                aux1.z = x13;
                normales.insert(std::pair<int, normal>(pos4, aux1)) ;
                pos4++;
            }
        }
    fclose(fp);



    fp=fopen(fname,"r");
    if (!fp){
        printf("can't open file %s\n", fname);
        exit(1);
    }
        float auxx, auxy, auxz;
        auxx = 0.0;
        auxy = 0.0;
        auxz = 0.0;
        while(!(feof(fp))){
            read1=fscanf(fp,"%c %f/%f/%f %f/%f/%f %f/%f/%f %f/%f/%f",&ch1,&x1,&x2,&x3,&y1,&y2,&y3,&z1,&z2,&z3,&w1,&w2,&w3);

            if (read1==4&&ch1=='f'){
                auxx = x1;
                auxy = x2;
                auxz = x3;
            }

            if (read1==10&&ch1=='f'){
                triangulos aux;
                aux.colorx = auxx;
                aux.colory = auxy;
                aux.colorz = auxz;
                aux.x = (int) x1;
                aux.normalx = (int)x3;
                aux.y = (int)y1;
                aux.normaly = (int)y3;
                aux.z = (int)z1;
                aux.normalz = (int)z3;
                if ((pos2 >= 6798 - 2000) && (pos2 <= 12637))
                    aux.rueda1 = true;
                else if ((pos2 >= 14350) && (pos2 <= 15500))
                    aux.manubrio = true;
                else if ((pos2 > 15500) && (pos2 <= 24232))
                    aux.rueda2 = true;
                else{
                    aux.rueda1 = false;
                    aux.rueda2 = false;
                    aux.manubrio = false;
                }
                carastri.insert(std::pair<int, triangulos>(pos2, aux));
                pos2++;
            }
            if (read1==13&&ch1=='f'){
                cuadrados aux;
                aux.colorx = auxx;
                aux.colory = auxy;
                aux.colorz = auxz;
                aux.x = (int)x1;
                aux.normalx = (int)x3;
                aux.y = (int)y1;
                aux.normaly = (int)y3;
                aux.z = (int)z1;
                aux.normalz = (int)z3;
                aux.w =(int) w1;
                aux.normalw =(int) w3;
                carascu.insert(std::pair<int, cuadrados>(pos3, aux));
                pos3++;
            }
        }

    fclose(fp);

    glNewList(auxtri, GL_COMPILE);
    for(std::map<int,triangulos>::iterator it = carastri.begin(); it != carastri.end(); ++it ){
        glBegin(GL_TRIANGLES);
        if (! (it->second.rueda1 || it->second.rueda2 || it->second.manubrio)){

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalx)->second.x, normales.find(it->second.normalx)->second.y,normales.find(it->second.normalx)->second.z);
            glVertex3f(vertices.find(it->second.x)->second.x, vertices.find(it->second.x)->second.y,vertices.find(it->second.x)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normaly)->second.x, normales.find(it->second.normaly)->second.y,normales.find(it->second.normaly)->second.z);
            glVertex3f(vertices.find(it->second.y)->second.x, vertices.find(it->second.y)->second.y,vertices.find(it->second.y)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalz)->second.x, normales.find(it->second.normalz)->second.y,normales.find(it->second.normalz)->second.z);
            glVertex3f(vertices.find(it->second.z)->second.x, vertices.find(it->second.z)->second.y,vertices.find(it->second.z)->second.z);


        }
        glEnd();
        }
    glEndList();

    glNewList(canio, GL_COMPILE);
    for(std::map<int,triangulos>::iterator it = carastri.begin(); it != carastri.end(); ++it ){
        glBegin(GL_TRIANGLES);
        if ((! (it->second.rueda1 || it->second.rueda2 || it->second.manubrio)) && it->first < 2600 && it->first > 2500){

            glColor4f(0.9,0.9,0.9,0.1);
            glNormal3f(normales.find(it->second.normalx)->second.x, normales.find(it->second.normalx)->second.y,normales.find(it->second.normalx)->second.z);
            glVertex3f(vertices.find(it->second.x)->second.x, vertices.find(it->second.x)->second.y,vertices.find(it->second.x)->second.z);

            glColor4f(0.9,0.9,0.9,0.1);
            glNormal3f(normales.find(it->second.normaly)->second.x, normales.find(it->second.normaly)->second.y,normales.find(it->second.normaly)->second.z);
            glVertex3f(vertices.find(it->second.y)->second.x, vertices.find(it->second.y)->second.y,vertices.find(it->second.y)->second.z);

            glColor4f(0.9,0.9,0.9,0.1);
            glNormal3f(normales.find(it->second.normalz)->second.x, normales.find(it->second.normalz)->second.y,normales.find(it->second.normalz)->second.z);
            glVertex3f(vertices.find(it->second.z)->second.x, vertices.find(it->second.z)->second.y,vertices.find(it->second.z)->second.z);
        }
        glEnd();
        }
    glEndList();

    glNewList(auxruedas1, GL_COMPILE);
    for(std::map<int,triangulos>::iterator it = carastri.begin(); it != carastri.end(); ++it ){
        glBegin(GL_TRIANGLES);
        if (it->second.rueda1){
            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalx)->second.x, normales.find(it->second.normalx)->second.y,normales.find(it->second.normalx)->second.z);
            glVertex3f(vertices.find(it->second.x)->second.x, vertices.find(it->second.x)->second.y,vertices.find(it->second.x)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normaly)->second.x, normales.find(it->second.normaly)->second.y,normales.find(it->second.normaly)->second.z);
            glVertex3f(vertices.find(it->second.y)->second.x, vertices.find(it->second.y)->second.y,vertices.find(it->second.y)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalz)->second.x, normales.find(it->second.normalz)->second.y,normales.find(it->second.normalz)->second.z);
            glVertex3f(vertices.find(it->second.z)->second.x, vertices.find(it->second.z)->second.y,vertices.find(it->second.z)->second.z);
        }
        glEnd();
        }
    glEndList();

    glNewList(auxruedas2, GL_COMPILE);
    for(std::map<int,triangulos>::iterator it = carastri.begin(); it != carastri.end(); ++it ){
        glBegin(GL_TRIANGLES);
        if (it->second.rueda2){
            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalx)->second.x, normales.find(it->second.normalx)->second.y,normales.find(it->second.normalx)->second.z);
            glVertex3f(vertices.find(it->second.x)->second.x, vertices.find(it->second.x)->second.y,vertices.find(it->second.x)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normaly)->second.x, normales.find(it->second.normaly)->second.y,normales.find(it->second.normaly)->second.z);
            glVertex3f(vertices.find(it->second.y)->second.x, vertices.find(it->second.y)->second.y,vertices.find(it->second.y)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalz)->second.x, normales.find(it->second.normalz)->second.y,normales.find(it->second.normalz)->second.z);
            glVertex3f(vertices.find(it->second.z)->second.x, vertices.find(it->second.z)->second.y,vertices.find(it->second.z)->second.z);
        }
        glEnd();
        }
    glEndList();

    glNewList(auxman, GL_COMPILE);
    for(std::map<int,triangulos>::iterator it = carastri.begin(); it != carastri.end(); ++it ){
        glBegin(GL_TRIANGLES);
        if (it->second.manubrio){
            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalx)->second.x, normales.find(it->second.normalx)->second.y,normales.find(it->second.normalx)->second.z);
            glVertex3f(vertices.find(it->second.x)->second.x, vertices.find(it->second.x)->second.y,vertices.find(it->second.x)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normaly)->second.x, normales.find(it->second.normaly)->second.y,normales.find(it->second.normaly)->second.z);
            glVertex3f(vertices.find(it->second.y)->second.x, vertices.find(it->second.y)->second.y,vertices.find(it->second.y)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalz)->second.x, normales.find(it->second.normalz)->second.y,normales.find(it->second.normalz)->second.z);
            glVertex3f(vertices.find(it->second.z)->second.x, vertices.find(it->second.z)->second.y,vertices.find(it->second.z)->second.z);
        }
        glEnd();
        }
    glEndList();

    glNewList(auxcuad, GL_COMPILE);
    for(std::map<int,cuadrados>::iterator it = carascu.begin(); it != carascu.end(); ++it ){
        glBegin(GL_QUADS);
            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalx)->second.x, normales.find(it->second.normalx)->second.y,normales.find(it->second.normalx)->second.z);
            glVertex3f(vertices.find(it->second.x)->second.x, vertices.find(it->second.x)->second.y,vertices.find(it->second.x)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normaly)->second.x, normales.find(it->second.normaly)->second.y,normales.find(it->second.normaly)->second.z);
            glVertex3f(vertices.find(it->second.y)->second.x, vertices.find(it->second.y)->second.y,vertices.find(it->second.y)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalz)->second.x, normales.find(it->second.normalz)->second.y,normales.find(it->second.normalz)->second.z);
            glVertex3f(vertices.find(it->second.z)->second.x, vertices.find(it->second.z)->second.y,vertices.find(it->second.z)->second.z);

            glColor3f(it->second.colorx,it->second.colory,it->second.colorz);
            glNormal3f(normales.find(it->second.normalw)->second.x, normales.find(it->second.normalw)->second.y,normales.find(it->second.normalw)->second.z);
            glVertex3f(vertices.find(it->second.w)->second.x, vertices.find(it->second.w)->second.y,vertices.find(it->second.w)->second.z);

        glEnd();
        }
        glEndList();

        carascu.clear();
        carastri.clear();
        vertices.clear();

}

void drawDucati(){
 	glPushMatrix();
        glTranslatef(0.0, 0.0, -panio/45);
        glRotatef(90,0.0,0.0,1.0);
        glRotatef(270,1.0,0.0,0.0);
        glRotatef(angulo, 0.0,0.0,1.0);
        glRotatef(panio, 1.0, 0.0, 0.0);
        glScalef(0.5,0.5, 0.5);
        glScalef(0.08, 0.08, 0.08);

        glPushMatrix();
            glTranslatef(0.0, 14.0, 30.0);
            glPushMatrix();
                for (float i = 0.0; i < ruedagiro1; i+=1.0)
                    if (acelerando)
                        glRotatef(-3.0, 1.0, 0.0, 0.0);
                    else glRotatef(3.0, 1.0, 0.0, 0.0);
                glTranslatef(0.0, -13.6, -30.5);
                glCallList(auxruedas1);
            glPopMatrix();
        glPopMatrix();

        glPushMatrix();
            glTranslatef(7.5,0.0,0.0);
                glPushMatrix();
                    glTranslatef(0.0, 13.0, -30.0);
                    glPushMatrix();
                    for (float i = 0.0; i < ruedagiro2; i+=1.0)
                        if (acelerando)
                            glRotatef(-3.0, 1.0, 0.0, 0.0);
                        else glRotatef(3.0, 1.0, 0.0, 0.0);
                        glTranslatef(0.0, -13.0, 30.0);
                        glRotatef(15, 0.0,1.0,0.0);
                        glCallList(auxruedas2);
                    glPopMatrix();
                glPopMatrix();
            glPushMatrix();
                glRotatef(15, 0.0,1.0,0.0);
                glCallList(auxman);
            glPopMatrix();
        glPopMatrix();

        glCallList(auxcuad);
        glCallList(auxtri);

  	glPopMatrix();
        if (!wireframe)
            glPolygonMode( GL_FRONT_AND_BACK, GL_FILL);
}

void drawEstela(){
    glPushMatrix();
        glTranslatef(0.0, 0.0, -panio/45);
        glRotatef(90,0.0,0.0,1.0);
        glRotatef(270,1.0,0.0,0.0);
        glRotatef(angulo, 0.0,0.0,1.0);
        glRotatef(panio, 1.0, 0.0, 0.0);
        glScalef(0.5,0.5, 0.5);
        glScalef(0.08, 0.08, 0.08);
        glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
            for (float ite = 0.0; ite < ruedagiro1/80.0; ite += 1.5){
                glPushMatrix();
                    glTranslatef(0.0 , 4.0, ite + 5.0);
                    glCallList(canio);
                glPopMatrix();
            }
        if (!wireframe)
                glPolygonMode( GL_FRONT_AND_BACK, GL_FILL);
    glPopMatrix();
}

void actualizarCam(float &x,float &y, float &z, float x_angle, float y_angle,float radius){
    z = cos(y_angle*M_PI/180) * cos(x_angle*M_PI/180) * radius;
    x = sin(y_angle*M_PI/180) * cos(x_angle*M_PI/180) * radius;
    y = sin(x_angle*M_PI/180) * radius;
}

void drawCalle(){

    float v = -16.0;
    float e = -20.0;


    while (v <= 240.0){
        glBindTexture(GL_TEXTURE_2D, textur[0]);

        glBegin(GL_QUADS);
        glTexCoord2d(0.0, 0.0);
        glVertex3f(e,0.0,0.0);

        glTexCoord2d(1.0, 0.0);
        glVertex3f(v,0.0,0.0);


        glTexCoord2d(1.0, 1.0);
        glVertex3f(v,4.0,0.0);

        glTexCoord2d(0.0, 1.0);
        glVertex3f(e,4.0,0.0);

        v += 4.0;
        e += 4.0;
    }
    glEnd();

}

void drawHUD(bool nivel1){
    if (nivel1)
        glBindTexture(GL_TEXTURE_2D, textur[5]);
    else
        glBindTexture(GL_TEXTURE_2D, textur[6]);
    glBegin(GL_QUADS);
        glTexCoord2d(1.0-0.5, 0.0);
        glVertex2f(800.0, 602.0 - 0.0);

        glTexCoord2d(- 0.5, 0.0);
        glVertex2f(244 + 0.7*450.0, 602.0 - 0.0);

        glTexCoord2d(- 0.5, 1.0 );
        glVertex2f(244 + 0.7*450.0, 602.0 - 92.0);

        glTexCoord2d(1.0 - 0.5, 1.0 );
        glVertex2f(800.0,602.0 -92.0);
    glEnd();

    glBindTexture(GL_TEXTURE_2D, textur[1]);
    glBegin(GL_QUADS);
        glTexCoord2d(1.0-0.75, 0.0);
        glVertex2f(242.5 - 0.0, 602.0 - 0.0);

        glTexCoord2d(- 0.75, 0.0);
        glVertex2f(242.5 + 0.7*450.0, 602.0 - 0.0);

        glTexCoord2d(- 0.75, 1.0 );
        glVertex2f(242.5 + 0.7*450.0, 602.0 - 0.7*260.0);

        glTexCoord2d(1.0 - 0.75, 1.0 );
        glVertex2f(242.5 - 0.0,602.0 - 0.7*260.0);
    glEnd();
}

void drawCEFA(bool on, int traslado){

     glPushMatrix();
        glTranslatef(630.0, 180.0, 0.0);
        glTranslatef(0.0, (traslado-1)*73, 0.0);
        glBegin(GL_POLYGON);
        for(int i=0; i<100; i++){
            float x = (float) cos(i*2*3.14/100);
            float y = (float) sin(i*2*3.14/100);
            if (on)
                glColor3f(0.0, 1.0, 0.0);
            else glColor3f(1.0, 0.0, 0.0);
            glVertex2f(x*20, y*20);
        }
    glEnd();
    glPopMatrix();

}

void drawSettings(int traslado){
    drawCEFA(wireframe,1);
    drawCEFA(textures,2);
    drawCEFA(luz,3);
    bool aux;
    if (gamespeed != 1)
        aux = true;
    else aux = false;
    drawCEFA(aux, 4);

    glPushMatrix();
        glTranslatef(50.0, 155, 0.0);
        glTranslatef(0.0, (traslado-1)*73, 0.0);
        if (traslado == 5){
            glTranslatef(225.0, -5.0, 0.0);
        }
        glBegin(GL_TRIANGLES);
            glColor3f(1.0, 0.0, 0.0);
            glVertex2f(0.0,0.0);
            glColor3f(1.0, 0.0, 0.0);
            glVertex2f(0.0, 50.0);
            glColor3f(1.0, 0.0, 0.0);
            glVertex2f(25.0, 25.0);
        glEnd();
    glPopMatrix();
    if (wireframe)
            glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, textur[2]);

    glBegin(GL_QUADS);
        glTexCoord2d(0.0-0.85, 0.0);
        glVertex2f(0.0, 602.0);

        glTexCoord2d(0.0-0.85, 1.0);
        glVertex2f(0.0, 0.0);

        glTexCoord2d(1.0-0.85, 1.0);
        glVertex2f(800.0, 0.0);

        glTexCoord2d(1.0-0.85, 0.0);
        glVertex2f(800.0, 602.0);
    glEnd();
    glDisable(GL_TEXTURE_2D);
     if (wireframe)
            glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
    Sleep(1);
}

void drawInicio(int nivel){

    if (wireframe)
            glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, textur[nivel+2]);

    glBegin(GL_QUADS);
        glTexCoord2d(0.0-0.85, 0.0);
        glVertex2f(0.0, 602.0);

        glTexCoord2d(0.0-0.85, 1.0);
        glVertex2f(0.0, 0.0);

        glTexCoord2d(1.0-0.85, 1.0);
        glVertex2f(800.0, 0.0);

        glTexCoord2d(1.0-0.85, 0.0);
        glVertex2f(800.0, 602.0);
    glEnd();
    glDisable(GL_TEXTURE_2D);
    if (wireframe)
            glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );


}

void drawVelocidad(float velocidad){
    glPushMatrix();
        glTranslatef(399, 585.0, 0.0);
        glRotatef(-89.0, 0.0, 0.0, 1.0);
        glRotatef(15*velocidad*velocidad*velocidad*110.0/gamespeed, 0.0, 0.0, 1.0);
        glTranslatef(-399, -585.0, 0.0);
        glBegin(GL_TRIANGLES);
            glColor3f(1.0, 0.0, 0.0);
            glVertex2d(403.0, 585.0);
            glColor3f(1.0, 0.0, 0.0);
            glVertex2d(395.0, 585.0);
            glColor3f(1.0, 0.0, 0.0);
            glVertex2d(399.0, 470.0);
        glEnd();
    glPopMatrix();
}

void loadTexture(GLuint texture, const char* archivo){

    FREE_IMAGE_FORMAT fif;
    fif = FreeImage_GetFIFFromFilename(archivo);
    FIBITMAP* image = FreeImage_Load(fif, archivo);
    image = FreeImage_ConvertTo24Bits(image);

    glBindTexture(GL_TEXTURE_2D, texture);

    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

    gluBuild2DMipmaps(GL_TEXTURE_2D, 3, FreeImage_GetWidth(image), FreeImage_GetHeight(image), GL_RGB, GL_UNSIGNED_BYTE, image->data); //bm
}

void initTexturas(){
    textures = new GLuint[8];
    glGenTextures(8, textur);

    loadTexture(textur[0], "asd.png");
    loadTexture(textur[1], "speed.jpg");
    loadTexture(textur[2], "settings.png");
    loadTexture(textur[3], "inicio1.png");
    loadTexture(textur[4], "inicio2.png");
    loadTexture(textur[5], "nivel1.png");
    loadTexture(textur[6], "nivel2.png");
}

float anguloT(float catOp, float catAdy){
    return (atan(catOp/catAdy) * 180 / PI);
}

float BezierXCurva1 (float t){
    float x_0 = 10.0;
    float x_1 = 12.08;
    float x_2 = 11.85;
    float x_3 = 14.0;
    return (1-t)*((1-t)*((1-t)*x_0 + t*x_1) + t*((1-t)*x_1 + t*x_2)) + t*((1-t)*((1-t)*x_1 + t*x_2) + t*((1-t)*x_2 + t*x_3));
}

float BezierZCurva1 (float t){
    float y_0 = 0;
    float y_1 = 0.07;
    float y_2 = 1.57;
    float y_3 = 0.0;
    return (1-t)*((1-t)*((1-t)*y_0 + t*y_1) + t*((1-t)*y_1+t*y_2)) + t*((1-t)*((1-t)*y_1 + t*y_2) + t*((1-t)*y_2 + t*y_3));
}

float BezierXCurva2 (float t){
    float x_0 = 8;
    float x_1 = 17.0;
    float x_2 = 15.0;
    float x_3 = 24.0;
    return (1-t)*((1-t)*((1-t)*x_0 + t*x_1) + t*((1-t)*x_1 + t*x_2)) + t*((1-t)*((1-t)*x_1 + t*x_2) + t*((1-t)*x_2 + t*x_3));
}

float BezierZCurva2 (float t){
    float y_0 = 0.0;
    float y_1 = 0.0;
    float y_2 = 8.0;
    float y_3 = 0.0;
    return (1-t)*((1-t)*((1-t)*y_0 + t*y_1) + t*((1-t)*y_1+t*y_2)) + t*((1-t)*((1-t)*y_1 + t*y_2) + t*((1-t)*y_2 + t*y_3));
}

float BezierXCurva3 (float t){
    float x_0 = 38.0;
    float x_1 = 53.0;
    float x_2 = 90.0;
    float x_3 = 102.0;
    return (1-t)*((1-t)*((1-t)*x_0 + t*x_1) + t*((1-t)*x_1 + t*x_2)) + t*((1-t)*((1-t)*x_1 + t*x_2) + t*((1-t)*x_2 + t*x_3));
}

float BezierZCurva3 (float t){
    float y_0 = 0.0;
    float y_1 = 6.0;
    float y_2 = 0.0;
    float y_3 = 0.0;
    return (1-t)*((1-t)*((1-t)*y_0 + t*y_1) + t*((1-t)*y_1+t*y_2)) + t*((1-t)*((1-t)*y_1 + t*y_2) + t*((1-t)*y_2 + t*y_3));
}

float BezierXCurva4 (float t){
    float x_0 = 14.0;
    float x_1 = 46.0;
    float x_2 = 109.0;
    float x_3 = 142.0;
    return (1-t)*((1-t)*((1-t)*x_0 + t*x_1) + t*((1-t)*x_1 + t*x_2)) + t*((1-t)*((1-t)*x_1 + t*x_2) + t*((1-t)*x_2 + t*x_3));
}

float BezierZCurva4 (float t){
    float y_0 = 0.0;
    float y_1 = 1.0;
    float y_2 = 8.0;
    float y_3 = 0.0;
    return (1-t)*((1-t)*((1-t)*y_0 + t*y_1) + t*((1-t)*y_1+t*y_2)) + t*((1-t)*((1-t)*y_1 + t*y_2) + t*((1-t)*y_2 + t*y_3));
}

void drawBezier1(){
    //bezier con puntos de control [(0,0)(2.08,0.07)(1.85,1.57)(4,0)]

    //tapa de costado
  glBegin(GL_TRIANGLES);
        glVertex3f(BezierXCurva1(0.00),0.0,-BezierZCurva1(0.0));
        glVertex3f(BezierXCurva1(0.1),0.0,0.0);
        glVertex3f(BezierXCurva1(0.1),0.0,-BezierZCurva1(0.1));
    glEnd();
    glBegin(GL_QUAD_STRIP);

        glVertex3f(BezierXCurva1(0.1),0.0,0.0);
        glVertex3f(BezierXCurva1(0.1),0.0,-BezierZCurva1(0.1));
        glVertex3f(BezierXCurva1(0.2),0,0.0);
        glVertex3f(BezierXCurva1(0.2),0,-BezierZCurva1(0.2));

        glVertex3f(BezierXCurva1(0.3),0,0.0);
        glVertex3f(BezierXCurva1(0.3),0,-BezierZCurva1(0.3));

        glVertex3f(BezierXCurva1(0.4),0,0.0);
        glVertex3f(BezierXCurva1(0.4),0,-BezierZCurva1(0.4));

        glVertex3f(BezierXCurva1(0.5),0,0);
        glVertex3f(BezierXCurva1(0.5),0,-BezierZCurva1(0.5));

        glVertex3f(BezierXCurva1(0.6),0,0);
        glVertex3f(BezierXCurva1(0.6),0,-BezierZCurva1(0.6));

        glVertex3f(BezierXCurva1(0.7),0,0);
        glVertex3f(BezierXCurva1(0.7),0,-BezierZCurva1(0.7));

        glVertex3f(BezierXCurva1(0.8),0,0);
        glVertex3f(BezierXCurva1(0.8),0,-BezierZCurva1(0.8));

        glVertex3f(BezierXCurva1(0.9),0,0);
        glVertex3f(BezierXCurva1(0.9),0,-BezierZCurva1(0.9));

        glVertex3f(BezierXCurva1(1.0),0,0);
        glVertex3f(BezierXCurva1(1.0),0,-BezierZCurva1(1.0));
    glEnd();

    glBegin(GL_TRIANGLES);
        glVertex3f(BezierXCurva1(0.00),4.0,-BezierZCurva1(0.0));
        glVertex3f(BezierXCurva1(0.1),4.0,0.0);
        glVertex3f(BezierXCurva1(0.1),4.0,-BezierZCurva1(0.1));
    glEnd();
    glBegin(GL_QUAD_STRIP);
        glVertex3f(BezierXCurva1(0.1),4.0,0.0);
        glVertex3f(BezierXCurva1(0.1),4.0,-BezierZCurva1(0.1));
        glVertex3f(BezierXCurva1(0.2),4,0.0);
        glVertex3f(BezierXCurva1(0.2),4,-BezierZCurva1(0.2));

        glVertex3f(BezierXCurva1(0.3),4,0.0);
        glVertex3f(BezierXCurva1(0.3),4,-BezierZCurva1(0.3));

        glVertex3f(BezierXCurva1(0.4),4,0.0);
        glVertex3f(BezierXCurva1(0.4),4,-BezierZCurva1(0.4));

        glVertex3f(BezierXCurva1(0.5),4,0);
        glVertex3f(BezierXCurva1(0.5),4,-BezierZCurva1(0.5));

        glVertex3f(BezierXCurva1(0.6),4,0);
        glVertex3f(BezierXCurva1(0.6),4,-BezierZCurva1(0.6));

        glVertex3f(BezierXCurva1(0.7),4,0);
        glVertex3f(BezierXCurva1(0.7),4,-BezierZCurva1(0.7));

        glVertex3f(BezierXCurva1(0.8),4,0);
        glVertex3f(BezierXCurva1(0.8),4,-BezierZCurva1(0.8));

        glVertex3f(BezierXCurva1(0.9),4,0);
        glVertex3f(BezierXCurva1(0.9),4,-BezierZCurva1(0.9));

        glVertex3f(BezierXCurva1(1.0),4,0);
        glVertex3f(BezierXCurva1(1.0),4,-BezierZCurva1(1.0));
    glEnd();
//termino de dibujar tapas

    glBindTexture(GL_TEXTURE_2D, textur[0]);
    glBegin(GL_QUAD_STRIP);
        //abarca un solo cuadrante
        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva1(0.00),0.0,-BezierZCurva1(0.0));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva1(0.00),4.0,-BezierZCurva1(0.0));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva1(0.1),0.0,-BezierZCurva1(0.1));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva1(0.1),4.0,-BezierZCurva1(0.1));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva1(0.2),0,-BezierZCurva1(0.2));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva1(0.2),4.0,-BezierZCurva1(0.2));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva1(0.3),0,-BezierZCurva1(0.3));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva1(0.3),4.0,-BezierZCurva1(0.3));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva1(0.4),0,-BezierZCurva1(0.4));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva1(0.4),4.0,-BezierZCurva1(0.4));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva1(0.5),0.0,-BezierZCurva1(0.5));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva1(0.5),4.0,-BezierZCurva1(0.5));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva1(0.6),0.0,-BezierZCurva1(0.6));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva1(0.6),4.0,-BezierZCurva1(0.6));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva1(0.7),0,-BezierZCurva1(0.7));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva1(0.7),4.0,-BezierZCurva1(0.7));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva1(0.8),0,-BezierZCurva1(0.8));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva1(0.8),4.0,-BezierZCurva1(0.8));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva1(0.9),0.0,-BezierZCurva1(0.9));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva1(0.9),4.0,-BezierZCurva1(0.9));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva1(1.0),0.0,-BezierZCurva1(1.0));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva1(1.0),4.0,-BezierZCurva1(1.0));
    glEnd();
}

void drawBezier2(){
    glBindTexture(GL_TEXTURE_2D, textur[0]);
    //tapa de costado
    glBegin(GL_TRIANGLES);
        glColor3f(0.1764,0.4353,0.0156);
        glVertex3f(BezierXCurva2(0.00),0.0,-BezierZCurva2(0.0));
        glVertex3f(BezierXCurva2(0.1),0.0,0.0);
        glVertex3f(BezierXCurva2(0.1),0.0,-BezierZCurva2(0.1));
    glEnd();
    glBegin(GL_QUAD_STRIP);
        glColor3f(0.1764,0.4353,0.0156);

        glVertex3f(BezierXCurva2(0.1),0.0,0.0);
        glVertex3f(BezierXCurva2(0.1),0.0,-BezierZCurva2(0.1));
        glVertex3f(BezierXCurva2(0.2),0,0.0);
        glVertex3f(BezierXCurva2(0.2),0,-BezierZCurva2(0.2));

        glVertex3f(BezierXCurva2(0.3),0,0.0);
        glVertex3f(BezierXCurva2(0.3),0,-BezierZCurva2(0.3));

        glVertex3f(BezierXCurva2(0.4),0,0.0);
        glVertex3f(BezierXCurva2(0.4),0,-BezierZCurva2(0.4));

        glVertex3f(BezierXCurva2(0.5),0,0);
        glVertex3f(BezierXCurva2(0.5),0,-BezierZCurva2(0.5));

        glVertex3f(BezierXCurva2(0.6),0,0);
        glVertex3f(BezierXCurva2(0.6),0,-BezierZCurva2(0.6));

        glVertex3f(BezierXCurva2(0.7),0,0);
        glVertex3f(BezierXCurva2(0.7),0,-BezierZCurva2(0.7));

        glVertex3f(BezierXCurva2(0.8),0,0);
        glVertex3f(BezierXCurva2(0.8),0,-BezierZCurva2(0.8));

        glVertex3f(BezierXCurva2(0.9),0,0);
        glVertex3f(BezierXCurva2(0.9),0,-BezierZCurva2(0.9));

        glVertex3f(BezierXCurva2(1.0),0,0);
        glVertex3f(BezierXCurva2(1.0),0,-BezierZCurva2(1.0));
    glEnd();

    glBegin(GL_TRIANGLES);
        glColor3f(0.1764,0.4353,0.0156);

        glVertex3f(BezierXCurva2(0.00),4.0,-BezierZCurva2(0.0));
        glVertex3f(BezierXCurva2(0.1),4.0,0.0);
        glVertex3f(BezierXCurva2(0.1),4.0,-BezierZCurva2(0.1));
    glEnd();
    glBegin(GL_QUAD_STRIP);
        glColor3f(0.1764,0.4353,0.0156);

        glVertex3f(BezierXCurva2(0.1),4.0,0.0);
        glVertex3f(BezierXCurva2(0.1),4.0,-BezierZCurva2(0.1));
        glVertex3f(BezierXCurva2(0.2),4,0.0);
        glVertex3f(BezierXCurva2(0.2),4,-BezierZCurva2(0.2));

        glVertex3f(BezierXCurva2(0.3),4,0.0);
        glVertex3f(BezierXCurva2(0.3),4,-BezierZCurva2(0.3));

        glVertex3f(BezierXCurva2(0.4),4,0.0);
        glVertex3f(BezierXCurva2(0.4),4,-BezierZCurva2(0.4));

        glVertex3f(BezierXCurva2(0.5),4,0);
        glVertex3f(BezierXCurva2(0.5),4,-BezierZCurva2(0.5));

        glVertex3f(BezierXCurva2(0.6),4,0);
        glVertex3f(BezierXCurva2(0.6),4,-BezierZCurva2(0.6));

        glVertex3f(BezierXCurva2(0.7),4,0);
        glVertex3f(BezierXCurva2(0.7),4,-BezierZCurva2(0.7));

        glVertex3f(BezierXCurva2(0.8),4,0);
        glVertex3f(BezierXCurva2(0.8),4,-BezierZCurva2(0.8));

        glVertex3f(BezierXCurva2(0.9),4,0);
        glVertex3f(BezierXCurva2(0.9),4,-BezierZCurva2(0.9));

        glVertex3f(BezierXCurva2(1.0),4,0);
        glVertex3f(BezierXCurva2(1.0),4,-BezierZCurva2(1.0));
    glEnd();
//termino de dibujar tapas
    glBegin(GL_QUAD_STRIP);
        //abarca 4 cuadrantes
        glColor3f(0.1764,0.4353,0.0156);
        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva2(0.00),0.0,-BezierZCurva2(0.0));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva2(0.00),4.0,-BezierZCurva2(0.0));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva2(0.1),0.0,-BezierZCurva2(0.1));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva2(0.1),4.0,-BezierZCurva2(0.1));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva2(0.2),0,-BezierZCurva2(0.2));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva2(0.2),4.0,-BezierZCurva2(0.2));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva2(0.3),0,-BezierZCurva2(0.3));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva2(0.3),4.0,-BezierZCurva2(0.3));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva2(0.4),0,-BezierZCurva2(0.4));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva2(0.4),4.0,-BezierZCurva2(0.4));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva2(0.5),0.0,-BezierZCurva2(0.5));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva2(0.5),4.0,-BezierZCurva2(0.5));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva2(0.6),0.0,-BezierZCurva2(0.6));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva2(0.6),4.0,-BezierZCurva2(0.6));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva2(0.7),0,-BezierZCurva2(0.7));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva2(0.7),4.0,-BezierZCurva2(0.7));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva2(0.8),0,-BezierZCurva2(0.8));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva2(0.8),4.0,-BezierZCurva2(0.8));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva2(0.9),0.0,-BezierZCurva2(0.9));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva2(0.9),4.0,-BezierZCurva2(0.9));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva2(1.0),0.0,-BezierZCurva2(1.0));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva2(1.0),4.0,-BezierZCurva2(1.0));
    glEnd();
}

void drawBezier3(){
    //bezier con puntos de control [(0,0)(15,6)(36,0)(64,0)]

    //tapa de costado

    glBindTexture(GL_TEXTURE_2D, textur[0]);
    glBegin(GL_TRIANGLES);
        glVertex3f(BezierXCurva3(0.00),0.0,-BezierZCurva3(0.0));
        glVertex3f(BezierXCurva3(0.1),0.0,0.0);
        glVertex3f(BezierXCurva3(0.1),0.0,-BezierZCurva3(0.1));
    glEnd();
    glBegin(GL_QUAD_STRIP);

        glVertex3f(BezierXCurva3(0.1),0.0,0.0);
        glVertex3f(BezierXCurva3(0.1),0.0,-BezierZCurva3(0.1));
        glVertex3f(BezierXCurva3(0.2),0,0.0);
        glVertex3f(BezierXCurva3(0.2),0,-BezierZCurva3(0.2));

        glVertex3f(BezierXCurva3(0.3),0,0.0);
        glVertex3f(BezierXCurva3(0.3),0,-BezierZCurva3(0.3));

        glVertex3f(BezierXCurva3(0.4),0,0.0);
        glVertex3f(BezierXCurva3(0.4),0,-BezierZCurva3(0.4));

        glVertex3f(BezierXCurva3(0.5),0,0);
        glVertex3f(BezierXCurva3(0.5),0,-BezierZCurva3(0.5));

        glVertex3f(BezierXCurva3(0.6),0,0);
        glVertex3f(BezierXCurva3(0.6),0,-BezierZCurva3(0.6));

        glVertex3f(BezierXCurva3(0.7),0,0);
        glVertex3f(BezierXCurva3(0.7),0,-BezierZCurva3(0.7));

        glVertex3f(BezierXCurva3(0.8),0,0);
        glVertex3f(BezierXCurva3(0.8),0,-BezierZCurva3(0.8));

        glVertex3f(BezierXCurva3(0.9),0,0);
        glVertex3f(BezierXCurva3(0.9),0,-BezierZCurva3(0.9));

        glVertex3f(BezierXCurva3(1.0),0,0);
        glVertex3f(BezierXCurva3(1.0),0,-BezierZCurva3(1.0));
    glEnd();

    glBegin(GL_TRIANGLES);
        glVertex3f(BezierXCurva3(0.00),4.0,-BezierZCurva3(0.0));
        glVertex3f(BezierXCurva3(0.1),4.0,0.0);
        glVertex3f(BezierXCurva3(0.1),4.0,-BezierZCurva3(0.1));
    glEnd();
    glBegin(GL_QUAD_STRIP);
        glVertex3f(BezierXCurva3(0.1),4.0,0.0);
        glVertex3f(BezierXCurva3(0.1),4.0,-BezierZCurva3(0.1));
        glVertex3f(BezierXCurva3(0.2),4,0.0);
        glVertex3f(BezierXCurva3(0.2),4,-BezierZCurva3(0.2));

        glVertex3f(BezierXCurva3(0.3),4,0.0);
        glVertex3f(BezierXCurva3(0.3),4,-BezierZCurva3(0.3));

        glVertex3f(BezierXCurva3(0.4),4,0.0);
        glVertex3f(BezierXCurva3(0.4),4,-BezierZCurva3(0.4));

        glVertex3f(BezierXCurva3(0.5),4,0);
        glVertex3f(BezierXCurva3(0.5),4,-BezierZCurva3(0.5));

        glVertex3f(BezierXCurva3(0.6),4,0);
        glVertex3f(BezierXCurva3(0.6),4,-BezierZCurva3(0.6));

        glVertex3f(BezierXCurva3(0.7),4,0);
        glVertex3f(BezierXCurva3(0.7),4,-BezierZCurva3(0.7));

        glVertex3f(BezierXCurva3(0.8),4,0);
        glVertex3f(BezierXCurva3(0.8),4,-BezierZCurva3(0.8));

        glVertex3f(BezierXCurva3(0.9),4,0);
        glVertex3f(BezierXCurva3(0.9),4,-BezierZCurva3(0.9));

        glVertex3f(BezierXCurva3(1.0),4,0);
        glVertex3f(BezierXCurva3(1.0),4,-BezierZCurva3(1.0));
    glEnd();
//termino de dibujar tapas

    glBegin(GL_QUAD_STRIP);
        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva3(0.00),0.0,-BezierZCurva3(0.0));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva3(0.00),4.0,-BezierZCurva3(0.0));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva3(0.1),0.0,-BezierZCurva3(0.1));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva3(0.1),4.0,-BezierZCurva3(0.1));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva3(0.2),0,-BezierZCurva3(0.2));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva3(0.2),4.0,-BezierZCurva3(0.2));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva3(0.3),0,-BezierZCurva3(0.3));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva3(0.3),4.0,-BezierZCurva3(0.3));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva3(0.4),0,-BezierZCurva3(0.4));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva3(0.4),4.0,-BezierZCurva3(0.4));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva3(0.5),0.0,-BezierZCurva3(0.5));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva3(0.5),4.0,-BezierZCurva3(0.5));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva3(0.6),0.0,-BezierZCurva3(0.6));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva3(0.6),4.0,-BezierZCurva3(0.6));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva3(0.7),0,-BezierZCurva3(0.7));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva3(0.7),4.0,-BezierZCurva3(0.7));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva3(0.8),0,-BezierZCurva3(0.8));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva3(0.8),4.0,-BezierZCurva3(0.8));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva3(0.9),0.0,-BezierZCurva3(0.9));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva3(0.9),4.0,-BezierZCurva3(0.9));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva3(1.0),0.0,-BezierZCurva3(1.0));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva3(1.0),4.0,-BezierZCurva3(1.0));
    glEnd();
}

void drawBezier4(){
    //bezier con puntos de control [(0,0)(32,1)(95,8)(128,0)]

    glBindTexture(GL_TEXTURE_2D, textur[0]);
    glBegin(GL_TRIANGLES);
        glColor3f(0.5,0.5,0.5);
        glVertex3f(BezierXCurva4(0.00),0.0,-BezierZCurva4(0.0));
        glVertex3f(BezierXCurva4(0.1),0.0,0.0);
        glVertex3f(BezierXCurva4(0.1),0.0,-BezierZCurva4(0.1));
    glEnd();
    glBegin(GL_QUAD_STRIP);

        glVertex3f(BezierXCurva4(0.1),0.0,0.0);
        glVertex3f(BezierXCurva4(0.1),0.0,-BezierZCurva4(0.1));
        glVertex3f(BezierXCurva4(0.2),0,0.0);
        glVertex3f(BezierXCurva4(0.2),0,-BezierZCurva4(0.2));

        glVertex3f(BezierXCurva4(0.3),0,0.0);
        glVertex3f(BezierXCurva4(0.3),0,-BezierZCurva4(0.3));

        glVertex3f(BezierXCurva4(0.4),0,0.0);
        glVertex3f(BezierXCurva4(0.4),0,-BezierZCurva4(0.4));

        glVertex3f(BezierXCurva4(0.5),0,0);
        glVertex3f(BezierXCurva4(0.5),0,-BezierZCurva4(0.5));

        glVertex3f(BezierXCurva4(0.6),0,0);
        glVertex3f(BezierXCurva4(0.6),0,-BezierZCurva4(0.6));

        glVertex3f(BezierXCurva4(0.7),0,0);
        glVertex3f(BezierXCurva4(0.7),0,-BezierZCurva4(0.7));

        glVertex3f(BezierXCurva4(0.8),0,0);
        glVertex3f(BezierXCurva4(0.8),0,-BezierZCurva4(0.8));

        glVertex3f(BezierXCurva4(0.9),0,0);
        glVertex3f(BezierXCurva4(0.9),0,-BezierZCurva4(0.9));

        glVertex3f(BezierXCurva4(1.0),0,0);
        glVertex3f(BezierXCurva4(1.0),0,-BezierZCurva4(1.0));
    glEnd();

    glBegin(GL_TRIANGLES);
        glVertex3f(BezierXCurva4(0.00),4.0,-BezierZCurva4(0.0));
        glVertex3f(BezierXCurva4(0.1),4.0,0.0);
        glVertex3f(BezierXCurva4(0.1),4.0,-BezierZCurva4(0.1));
    glEnd();
    glBegin(GL_QUAD_STRIP);
        glVertex3f(BezierXCurva4(0.1),4.0,0.0);
        glVertex3f(BezierXCurva4(0.1),4.0,-BezierZCurva4(0.1));
        glVertex3f(BezierXCurva4(0.2),4,0.0);
        glVertex3f(BezierXCurva4(0.2),4,-BezierZCurva4(0.2));

        glVertex3f(BezierXCurva4(0.3),4,0.0);
        glVertex3f(BezierXCurva4(0.3),4,-BezierZCurva4(0.3));

        glVertex3f(BezierXCurva4(0.4),4,0.0);
        glVertex3f(BezierXCurva4(0.4),4,-BezierZCurva4(0.4));

        glVertex3f(BezierXCurva4(0.5),4,0);
        glVertex3f(BezierXCurva4(0.5),4,-BezierZCurva4(0.5));

        glVertex3f(BezierXCurva4(0.6),4,0);
        glVertex3f(BezierXCurva4(0.6),4,-BezierZCurva4(0.6));

        glVertex3f(BezierXCurva4(0.7),4,0);
        glVertex3f(BezierXCurva4(0.7),4,-BezierZCurva4(0.7));

        glVertex3f(BezierXCurva4(0.8),4,0);
        glVertex3f(BezierXCurva4(0.8),4,-BezierZCurva4(0.8));

        glVertex3f(BezierXCurva4(0.9),4,0);
        glVertex3f(BezierXCurva4(0.9),4,-BezierZCurva4(0.9));

        glVertex3f(BezierXCurva4(1.0),4,0);
        glVertex3f(BezierXCurva4(1.0),4,-BezierZCurva4(1.0));
    glEnd();

    glBegin(GL_QUAD_STRIP);
        //abarca 32 cuadrantes (de 4x4)
        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva4(0.00),0.0,-BezierZCurva4(0.0));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva4(0.00),4.0,-BezierZCurva4(0.0));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva4(0.1),0.0,-BezierZCurva4(0.1));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva4(0.1),4.0,-BezierZCurva4(0.1));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva4(0.2),0,-BezierZCurva4(0.2));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva4(0.2),4.0,-BezierZCurva4(0.2));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva4(0.3),0,-BezierZCurva4(0.3));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva4(0.3),4.0,-BezierZCurva4(0.3));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva4(0.4),0,-BezierZCurva4(0.4));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva4(0.4),4.0,-BezierZCurva4(0.4));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva4(0.5),0.0,-BezierZCurva4(0.5));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva4(0.5),4.0,-BezierZCurva4(0.5));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva4(0.6),0.0,-BezierZCurva4(0.6));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva4(0.6),4.0,-BezierZCurva4(0.6));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva4(0.7),0,-BezierZCurva4(0.7));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva4(0.7),4.0,-BezierZCurva4(0.7));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva4(0.8),0,-BezierZCurva4(0.8));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva4(0.8),4.0,-BezierZCurva4(0.8));

        glTexCoord2d(1.0, 0.0);
        glVertex3f(BezierXCurva4(0.9),0.0,-BezierZCurva4(0.9));
        glTexCoord2d(1.0, 1.0);
        glVertex3f(BezierXCurva4(0.9),4.0,-BezierZCurva4(0.9));

        glTexCoord2d(0.0, 0.0);
        glVertex3f(BezierXCurva4(1.0),0.0,-BezierZCurva4(1.0));
        glTexCoord2d(0.0, 1.0);
        glVertex3f(BezierXCurva4(1.0),4.0,-BezierZCurva4(1.0));
    glEnd();
}

float rectaEntreDosPuntos_Y(float x1, float y1, float x2, float y2, float x){
    float y;
    //x = (y*(x2-x1) - y1*x2 +x1*y2)/(y2-y1);
    y = (x*(y2-y1) + x2*y1 - x1*y2)/(x2-x1);
    return y;

}

int main(int argc, char *argv[]) {
    float anga=45;
    float angb=-15;
    float rad=-10;
    bool moverCam=false;

    if(SDL_Init(SDL_INIT_VIDEO)<0) {
        cerr << "No se pudo iniciar SDL: " << SDL_GetError() << endl;
        exit(1);
    }
    x=0;
    y=0;
    z=rad;
    atexit(SDL_Quit);

    Uint32 flags = SDL_DOUBLEBUF | SDL_HWSURFACE | SDL_OPENGL;

    if(SDL_SetVideoMode(800, 600, 32, flags)==NULL) {
        cerr << "No se pudo establecer el modo de video: " << SDL_GetError() << endl;
        exit(1);
    }

    if(SDL_EnableKeyRepeat(10, 10)<0) {
        cerr << "No se pudo establecer el modo key-repeat: " << SDL_GetError() << endl;
        exit(1);
    }

    glMatrixMode(GL_PROJECTION);
    glClearColor(0.0, 0.0784, 0.1568, 1);
    gluPerspective(45, 800/600.f, 0.1, 100);
    glEnable(GL_DEPTH_TEST);
    glMatrixMode(GL_MODELVIEW);

    ///CARGADO DE MOTO///
    loadVerticesMoto("data/ducati.obj");

    bool fin = false;
    bool pausa = false;
    SDL_Event evento;
    float equis = 0.0;
    float velocidad = 0.0;
    float eyis = 0.0;
    float ezis = 0.0;
    bool ajustes = false;
    bool inicio1 = true;
    bool inicio2 = false;
    bool nivel1 = false;
    bool nivel2 = false;
    int opt = 1;
    float alturaReal = 1;
    float hl = 1;
    float diferencia;
    float alturaInicial = 2.0;
    float anteriorEzis = 0;
    float angusYoung = 0;
    float nextEzis = 0;
    diferencia = alturaInicial - alturaReal;
    bool flag = false;
    clock_t t_inicio, t_fin;
    initTexturas();

    do{
        glEnable(GL_NORMALIZE);
        t_inicio = clock();
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        gluPerspective(45, 800/600.f, 0.1, 100);
        glMatrixMode(GL_MODELVIEW);
        gluLookAt(x,y,-z,0,0,0,0,1,0);

        ///LUZ///
        glShadeModel(GL_SMOOTH);
        if (luz){
            GLfloat pos[] = {0.33, 0.33, 0.52, 1.0};
            GLfloat shin[] = {10.0};
            GLfloat diffuse[] = {0.43, 0.47, 0.54, 1.0};
            GLfloat luz_ambiental[] = { 0.8, 0.8, 0.8, 1.0 };
            glLightfv(GL_LIGHT0, GL_SPECULAR, pos);
            glLightfv(GL_LIGHT0, GL_SHININESS, shin);
            glLightModelfv (GL_LIGHT_MODEL_AMBIENT, luz_ambiental);
            glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,  diffuse);
            glEnable(GL_LIGHTING);
            glEnable(GL_LIGHT0);
            glEnable(GL_DEPTH_TEST);
            glEnable(GL_COLOR_MATERIAL);
        }

        glRotatef(90,1.0,0.0,0.0);   // angle, x-axis, y-axis, z-axis
        actualizarCam(x,y,z,angb,anga,rad);
        int numSteps=100;

        ///AJUSTES///
        if (ajustes){
            glClearColor(0.0, 0.0784, 0.1568, 1);
            glMatrixMode(GL_PROJECTION);
            glLoadIdentity();
            glDisable(GL_LIGHTING);
            glOrtho(0, 800, 600, 0, -1, 1);
            glMatrixMode(GL_MODELVIEW);
            glLoadIdentity();
            drawSettings(opt);
            glEnable(GL_LIGHTING);
            glClearColor(0.0, 0.0784, 0.1568, 1);
        }


        ///LLAMADO AL INICIO DEL NIVEL 1///
        if (inicio1){
            glClearColor(0.0, 0.0784, 0.1568, 1);
            glMatrixMode(GL_PROJECTION);
            glLoadIdentity();
            glDisable(GL_LIGHTING);
            glOrtho(0, 800, 600, 0, -1, 1);
            glMatrixMode(GL_MODELVIEW);
            glLoadIdentity();
            drawInicio(1);
            glEnable(GL_LIGHTING);
            glClearColor(0.0, 0.0784, 0.1568, 1);
        }

        ///LLAMADO AL INICIO DEL NIVEL 2///
        if (inicio2){
            glClearColor(0.0, 0.0784, 0.1568, 1);
            glMatrixMode(GL_PROJECTION);
            glLoadIdentity();
            glDisable(GL_LIGHTING);
            glOrtho(0, 800, 600, 0, -1, 1);
            glMatrixMode(GL_MODELVIEW);
            glLoadIdentity();
            drawInicio(2);
            glEnable(GL_LIGHTING);
            glClearColor(0.0, 0.0784, 0.1568, 1);
        }

        ///WIREFRAME!!///
        if (wireframe)
            glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
        else
            glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );

        ///CARGO NIVEL 1///
        if (nivel1){
            if (equis > 0 && equis < 8){
                alturaReal = hl;
                angusYoung = 0;
            }
            if (equis >= 6 && equis + 2 < BezierXCurva2(0.1)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva2(0.00), BezierZCurva2(0.0), BezierXCurva2(0.1),BezierZCurva2(0.1), equis+2) + 1;
                angusYoung = anguloT((BezierZCurva2(0.1)- BezierZCurva2(0.0)),(BezierXCurva2(0.10) - BezierXCurva2(0.00)));
            }
            else if (equis + 2 >= BezierXCurva2(0.1) && equis + 2 < BezierXCurva2(0.2)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva2(0.10), BezierZCurva2(0.1), BezierXCurva2(0.2),BezierZCurva2(0.2), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva2(0.2)- BezierZCurva2(0.1)),(BezierXCurva2(0.20) - BezierXCurva2(0.10)));
            }
            else if (equis + 2 >= BezierXCurva2(0.2) && equis + 2 < BezierXCurva2(0.3)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva2(0.20), BezierZCurva2(0.2), BezierXCurva2(0.3),BezierZCurva2(0.3), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva2(0.3)- BezierZCurva2(0.2)),(BezierXCurva2(0.30) - BezierXCurva2(0.20)));
            }
            else if (equis + 2 >= BezierXCurva2(0.3) && equis + 2 < BezierXCurva2(0.4)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva2(0.30), BezierZCurva2(0.3), BezierXCurva2(0.4),BezierZCurva2(0.4), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva2(0.4)- BezierZCurva2(0.3)),(BezierXCurva2(0.40) - BezierXCurva2(0.30)));
            }
            else if (equis + 2 >= BezierXCurva2(0.4) && equis + 2 < BezierXCurva2(0.5)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva2(0.40), BezierZCurva2(0.4), BezierXCurva2(0.5),BezierZCurva2(0.5), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva2(0.5)- BezierZCurva2(0.4)),(BezierXCurva2(0.50) - BezierXCurva2(0.40)));
            }
            else if (equis + 2 >= BezierXCurva2(0.5) && equis + 2 < BezierXCurva2(0.6)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva2(0.50), BezierZCurva2(0.5), BezierXCurva2(0.6),BezierZCurva2(0.6), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva2(0.6)- BezierZCurva2(0.5)),(BezierXCurva2(0.60) - BezierXCurva2(0.5)));
            }
            else if (equis + 2 >= BezierXCurva2(0.6) && equis + 2 < BezierXCurva2(0.7)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva2(0.60), BezierZCurva2(0.6), BezierXCurva2(0.7),BezierZCurva2(0.7), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva2(0.7)- BezierZCurva2(0.6)),(BezierXCurva2(0.70) - BezierXCurva2(0.60)));
            }
            else if (equis + 2 >= BezierXCurva2(0.7) && equis + 2 < BezierXCurva2(0.8)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva2(0.70), BezierZCurva2(0.7), BezierXCurva2(0.8),BezierZCurva2(0.8), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva2(0.8)- BezierZCurva2(0.7)),(BezierXCurva2(0.80) - BezierXCurva2(0.70)));
            }
            else if (equis + 2 >= BezierXCurva2(0.8) && equis + 2 < BezierXCurva2(0.9)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva2(0.80), BezierZCurva2(0.8), BezierXCurva2(0.9),BezierZCurva2(0.9), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva2(0.9)- BezierZCurva2(0.8)),(BezierXCurva2(0.90) - BezierXCurva2(0.80)));
            }
            else if (equis + 2 >= BezierXCurva2(0.9) && equis + 2 < BezierXCurva2(1.0)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva2(0.90), BezierZCurva2(0.9), BezierXCurva2(1.0),BezierZCurva2(1.0), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva2(1.0)- BezierZCurva2(0.9)),(BezierXCurva2(1.00) - BezierXCurva2(0.90)));
            }
            else if (equis + 2 >= BezierXCurva2(1.0) && equis + 2 < 38){
                alturaReal = hl;
                angusYoung = 0;
            }


            if (equis + 2 >= 38.0 && equis + 2 < 32 + BezierXCurva3(0.1)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva3(0.00), BezierZCurva3(0.0), BezierXCurva3(0.1),BezierZCurva3(0.1), equis+2) + 1;
                angusYoung = anguloT((BezierZCurva3(0.1)- BezierZCurva3(0.0)),(BezierXCurva3(0.10) - BezierXCurva3(0.00)));
            }
            if (equis + 2 >= BezierXCurva3(0.1) && equis + 2 < BezierXCurva3(0.2)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva3(0.10), BezierZCurva3(0.1), BezierXCurva3(0.2),BezierZCurva3(0.2), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva3(0.2)- BezierZCurva3(0.1)),(BezierXCurva3(0.20) - BezierXCurva3(0.10)));
            }
            else if (equis + 2 >= BezierXCurva3(0.2) && equis + 2 < BezierXCurva3(0.3)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva3(0.20), BezierZCurva3(0.2), BezierXCurva3(0.3),BezierZCurva3(0.3), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva3(0.3)- BezierZCurva3(0.2)),(BezierXCurva3(0.30) - BezierXCurva3(0.20)));
            }
            else if (equis + 2 >= BezierXCurva3(0.3) && equis + 2 < BezierXCurva3(0.4)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva3(0.30), BezierZCurva3(0.3), BezierXCurva3(0.4),BezierZCurva3(0.4), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva3(0.4)- BezierZCurva3(0.3)),(BezierXCurva3(0.40) - BezierXCurva3(0.30)));
            }
            else if (equis + 2 >= BezierXCurva3(0.4) && equis + 2 < BezierXCurva3(0.5)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva3(0.40), BezierZCurva3(0.4), BezierXCurva3(0.5),BezierZCurva3(0.5), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva3(0.5)- BezierZCurva3(0.4)),(BezierXCurva3(0.50) - BezierXCurva3(0.40)));
            }
            else if (equis + 2 >= BezierXCurva3(0.5) && equis + 2 < BezierXCurva3(0.6)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva3(0.50), BezierZCurva3(0.5), BezierXCurva3(0.6),BezierZCurva3(0.6), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva3(0.6)- BezierZCurva3(0.5)),(BezierXCurva3(0.60) - BezierXCurva3(0.5)));
            }
            else if (equis + 2 >= BezierXCurva3(0.6) && equis + 2 < BezierXCurva3(0.7)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva3(0.60), BezierZCurva3(0.6), BezierXCurva3(0.7),BezierZCurva3(0.7), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva3(0.7)- BezierZCurva3(0.6)),(BezierXCurva3(0.70) - BezierXCurva3(0.60)));
            }
            else if (equis + 2 >= BezierXCurva3(0.7) && equis + 2 < BezierXCurva3(0.8)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva3(0.70), BezierZCurva3(0.7), BezierXCurva3(0.8),BezierZCurva3(0.8), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva3(0.8)- BezierZCurva3(0.7)),(BezierXCurva3(0.80) - BezierXCurva3(0.70)));
            }
            else if (equis + 2 >= BezierXCurva3(0.8) && equis + 2 < BezierXCurva3(0.9)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva3(0.80), BezierZCurva3(0.8), BezierXCurva3(0.9),BezierZCurva3(0.9), equis + 2) + 1;
            angusYoung = anguloT((BezierZCurva3(0.9)- BezierZCurva3(0.8)),(BezierXCurva3(0.90) - BezierXCurva3(0.80)));
            }
            else if (equis + 2 >= BezierXCurva3(0.9) && equis + 2 < BezierXCurva3(1.0)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva3(0.90), BezierZCurva3(0.9), BezierXCurva3(1.0),BezierZCurva3(1.0), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva3(1.0)- BezierZCurva3(0.9)),(BezierXCurva3(1.00) - BezierXCurva3(0.90)));
            }
            else if (equis + 2 >= BezierXCurva3(1.0) ){
                alturaReal = hl;
                angusYoung = 0;
            }
            if (equis + 2 >= BezierXCurva3(1.0)){
                alturaReal = hl;
                angusYoung = 0;
            }
            glPushMatrix();
                if (angusYoung > 0)
                    glTranslatef(-equis ,eyis, -1*alturaReal+1.0);
                else
                    glTranslatef(-equis ,eyis, ezis+1.0);
                    glPushMatrix();
                    glTranslatef(-2.0,-2.0,1.0);
                    if (textures)
                        glEnable(GL_TEXTURE_2D);
                        ///DIBUJO NIVEL///
                        drawBezier2();
                        drawBezier3();
                        drawCalle();
                    if (textures)
                        glDisable(GL_TEXTURE_2D);
                    glClearColor(0.0, 0.0784, 0.1568, 1);
                glPopMatrix();
             glPopMatrix();
        }

        ///DIBUJO NIVEL 2///
        if (nivel2){
            if (equis > 0 && equis < 10){
                alturaReal = hl;
                angusYoung = 0;
            }
            if (equis + 2 >= 10 && equis + 2 < BezierXCurva1(0.1)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva1(0.00), BezierZCurva1(0.0), BezierXCurva1(0.1),BezierZCurva1(0.1), equis+2) + 1;
                angusYoung = anguloT((BezierZCurva1(0.1)- BezierZCurva1(0.0)),(BezierXCurva1(0.10) - BezierXCurva1(0.00)));
            }
            else if (equis + 2 >= BezierXCurva1(0.1) && equis + 2 < BezierXCurva1(0.2)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva1(0.10), BezierZCurva1(0.1), BezierXCurva1(0.2),BezierZCurva1(0.2), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva1(0.2)- BezierZCurva1(0.1)),(BezierXCurva1(0.20) - BezierXCurva1(0.10)));
            }
            else if (equis + 2 >= BezierXCurva1(0.2) && equis + 2 < BezierXCurva1(0.3)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva1(0.20), BezierZCurva1(0.2), BezierXCurva1(0.3),BezierZCurva1(0.3), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva1(0.3)- BezierZCurva1(0.2)),(BezierXCurva1(0.30) - BezierXCurva1(0.20)));
            }
            else if (equis + 2 >= BezierXCurva1(0.3) && equis + 2 < BezierXCurva1(0.4)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva1(0.30), BezierZCurva1(0.3), BezierXCurva1(0.4),BezierZCurva1(0.4), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva1(0.4)- BezierZCurva1(0.3)),(BezierXCurva1(0.40) - BezierXCurva1(0.30)));
            }
            else if (equis + 2 >= BezierXCurva1(0.4) && equis + 2 < BezierXCurva1(0.5)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva1(0.40), BezierZCurva1(0.4), BezierXCurva1(0.5),BezierZCurva1(0.5), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva1(0.5)- BezierZCurva1(0.4)),(BezierXCurva1(0.50) - BezierXCurva1(0.40)));
            }
            else if (equis + 2 >= BezierXCurva1(0.5) && equis + 2 < BezierXCurva1(0.6)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva1(0.50), BezierZCurva1(0.5), BezierXCurva1(0.6),BezierZCurva1(0.6), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva1(0.6)- BezierZCurva1(0.5)),(BezierXCurva1(0.60) - BezierXCurva1(0.5)));
            }
            else if (equis + 2 >= BezierXCurva1(0.6) && equis + 2 < BezierXCurva1(0.7)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva1(0.60), BezierZCurva1(0.6), BezierXCurva1(0.7),BezierZCurva1(0.7), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva1(0.7)- BezierZCurva1(0.6)),(BezierXCurva1(0.70) - BezierXCurva1(0.60)));
            }
            else if (equis + 2 >= BezierXCurva1(0.7) && equis + 2 < BezierXCurva1(0.8)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva1(0.70), BezierZCurva1(0.7), BezierXCurva1(0.8),BezierZCurva1(0.8), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva1(0.8)- BezierZCurva1(0.7)),(BezierXCurva1(0.80) - BezierXCurva1(0.70)));
            }
            else if (equis + 2 >= BezierXCurva1(0.8) && equis + 2 < BezierXCurva1(0.9)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva1(0.80), BezierZCurva1(0.8), BezierXCurva1(0.9),BezierZCurva1(0.9), equis + 2) + 1;
            angusYoung = anguloT((BezierZCurva1(0.9)- BezierZCurva1(0.8)),(BezierXCurva1(0.90) - BezierXCurva1(0.80)));
            }
            else if (equis + 2 >= BezierXCurva1(0.9) && equis + 2 < BezierXCurva1(1.0)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva1(0.90), BezierZCurva1(0.9), BezierXCurva1(1.0),BezierZCurva1(1.0), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva1(1.0)- BezierZCurva1(0.9)),(BezierXCurva1(1.00) - BezierXCurva1(0.90)));
            }
            if (equis + 2 >= BezierXCurva1(1.0) && equis + 2 < BezierXCurva4(0.1)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva4(0.00), BezierZCurva4(0.0), BezierXCurva4(0.1),BezierZCurva4(0.1), equis+2) + 1;
                angusYoung = anguloT((BezierZCurva4(0.1)- BezierZCurva4(0.0)),(BezierXCurva4(0.10) - BezierXCurva4(0.00)));
            }
            if (equis + 2 >= BezierXCurva4(0.1) && equis + 2 < BezierXCurva4(0.2)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva4(0.10), BezierZCurva4(0.1), BezierXCurva4(0.2),BezierZCurva4(0.2), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva4(0.2)- BezierZCurva4(0.1)),(BezierXCurva4(0.20) - BezierXCurva4(0.10)));
            }
            else if (equis + 2 >= BezierXCurva4(0.2) && equis + 2 < BezierXCurva4(0.3)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva4(0.20), BezierZCurva4(0.2), BezierXCurva4(0.3),BezierZCurva4(0.3), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva4(0.3)- BezierZCurva4(0.2)),(BezierXCurva4(0.30) - BezierXCurva4(0.20)));
            }
            else if (equis + 2 >= BezierXCurva4(0.3) && equis + 2 < BezierXCurva4(0.4)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva4(0.30), BezierZCurva4(0.3), BezierXCurva4(0.4),BezierZCurva4(0.4), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva4(0.4)- BezierZCurva4(0.3)),(BezierXCurva4(0.40) - BezierXCurva4(0.30)));
            }
            else if (equis + 2 >= BezierXCurva4(0.4) && equis + 2 < BezierXCurva4(0.5)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva4(0.40), BezierZCurva4(0.4), BezierXCurva4(0.5),BezierZCurva4(0.5), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva4(0.5)- BezierZCurva4(0.4)),(BezierXCurva4(0.50) - BezierXCurva4(0.40)));
            }
            else if (equis + 2 >= BezierXCurva4(0.5) && equis + 2 < BezierXCurva4(0.6)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva4(0.50), BezierZCurva4(0.5), BezierXCurva4(0.6),BezierZCurva4(0.6), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva4(0.6)- BezierZCurva4(0.5)),(BezierXCurva4(0.60) - BezierXCurva4(0.5)));
            }
            else if (equis + 2 >= BezierXCurva4(0.6) && equis + 2 < BezierXCurva4(0.7)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva4(0.60), BezierZCurva4(0.6), BezierXCurva4(0.7),BezierZCurva4(0.7), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva4(0.7)- BezierZCurva4(0.6)),(BezierXCurva4(0.70) - BezierXCurva4(0.60)));
            }
            else if (equis + 2 >= BezierXCurva4(0.7) && equis + 2 < BezierXCurva4(0.8)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva4(0.70), BezierZCurva4(0.7), BezierXCurva4(0.8),BezierZCurva4(0.8), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva4(0.8)- BezierZCurva4(0.7)),(BezierXCurva4(0.80) - BezierXCurva4(0.70)));
            }
            else if (equis + 2 >= BezierXCurva4(0.8) && equis + 2 < BezierXCurva4(0.9)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva4(0.80), BezierZCurva4(0.8), BezierXCurva4(0.9),BezierZCurva4(0.9), equis + 2) + 1;
            angusYoung = anguloT((BezierZCurva4(0.9)- BezierZCurva4(0.8)),(BezierXCurva4(0.90) - BezierXCurva4(0.80)));
            }
            else if (equis + 2 >= BezierXCurva4(0.9) && equis + 2 < BezierXCurva4(1.0)){
                alturaReal = -rectaEntreDosPuntos_Y(BezierXCurva4(0.90), BezierZCurva4(0.9), BezierXCurva4(1.0),BezierZCurva4(1.0), equis + 2) + 1;
                angusYoung = anguloT((BezierZCurva4(1.0)- BezierZCurva4(0.9)),(BezierXCurva4(1.00) - BezierXCurva4(0.90)));
            }
            else if (equis + 2 >= BezierXCurva4(1.0)){
                alturaReal = hl;
                angusYoung = 0;
            }

            glPushMatrix();
                if (angusYoung > 0)
                    glTranslatef(-equis ,eyis, -1*alturaReal+1.0);
                else
                    glTranslatef(-equis ,eyis, ezis+1.0);
                glPushMatrix();
                    glTranslatef(-2.0,-2.0,1.0);
                    if (textures)
                        glEnable(GL_TEXTURE_2D);
                        ///DIBUJO NIVEL///
                        drawBezier1();
                        drawBezier4();
                        drawCalle();
                    if (textures)
                        glDisable(GL_TEXTURE_2D);
                    glClearColor(0.0, 0.0784, 0.1568, 1);
                glPopMatrix();
             glPopMatrix();

            glPushMatrix();
            glPopMatrix();
        }

        ///DIBUJO MOTO///
        glPushMatrix();
            glTranslatef(0.0,0.0,hl);
            glRotatef(angusYoung, 0, 1, 0);
            drawDucati();
            drawEstela();
        glPopMatrix();

        ///PROYECCION ORTONORMAL + DIBUJO HUD///
        if (!ajustes){
            glMatrixMode(GL_PROJECTION);
            glLoadIdentity();
            glDisable(GL_LIGHTING);
            glOrtho(0, 800, 600, 0, -1, 1);
            glMatrixMode(GL_MODELVIEW);
            glLoadIdentity();
            drawVelocidad(velocidad);
            glEnable(GL_TEXTURE_2D);
            if (wireframe)
                glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
            drawHUD(nivel1);
            if (wireframe)
                glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
            glDisable(GL_TEXTURE_2D);
            glClearColor(0.0, 0.0784, 0.1568, 1);
        }

        ///DORMIR PARA FPS///
        t_fin = clock();
        float deltaT = (t_fin - t_inicio);
        float th = (1/FPS)*1000;
        if (th > deltaT)
            Sleep(th - deltaT);

        diferencia = alturaReal + ezis;
        if (diferencia > 0.0){
            if (!flag){
                nextEzis = ezis - 0.065;
                if ((alturaReal + nextEzis) >= 0){
                    ezis = ezis - 0.065;
                    flag = true;
                }
            }else{
                anteriorEzis = ezis + 0.065;
                if ((alturaReal + anteriorEzis) >= 0){
                    ezis = ezis - 0.065;
                }
            }
        }
        if (diferencia < 0.0){
            if (flag){
                anteriorEzis = ezis +0.065;
                flag = false;
                ezis = ezis + 0.065;
            }else{
                anteriorEzis = ezis +0.065;
                diferencia = diferencia - ezis;
                ezis = ezis + 0.065;
            }
        }
        if (diferencia == 0)
            ezis = alturaReal;

        ///FRENADO///
        if (velocidad > 0.0){
                acelerando = false;
                velocidad -= 0.0008;
                equis += velocidad;
        }
        if (velocidad == 0.0){
            ruedagiro1 = 0.0;
            ruedagiro2 = 0.0;
        }

        if (equis > 240.0)
            if (nivel1){
                inicio2 = true;
                nivel1 = false;
            }
        if (equis > 240.0)
            if (nivel2){
                inicio1 = true;
                nivel2 = false;
            }

        ///REUBICACIONES///
        if (ruedagiro1 > 0.0)
            ruedagiro1 -= 2.5;
        if (ruedagiro2 > 0.0)
            ruedagiro2 -= 2.5;
        if (panio>0){
            ruedagiro2 -= 1.5;
            panio-= 1.0;
        }
        else ruedagiro2 = ruedagiro1;
        if(angulo>0)
            angulo -= 1;
        if(angulo<0)
            angulo+= 1;

        ///TECLAS///
        float ip,jp;
        int xm,ym,xn,yn;
        SDL_GetMouseState(&xm, &ym);
        while(SDL_PollEvent(&evento)){
            switch(evento.type){
                case SDL_MOUSEBUTTONDOWN:
                    if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(3)){
                        moverCam=true;
                    }
                    break;
                case SDL_MOUSEBUTTONUP:
                    moverCam=false;
                    break;
                case SDL_MOUSEMOTION:
                    if(moverCam){
                        if (evento.motion.yrel<0 && angb < 80 )
                            angb-=evento.motion.yrel*0.4;//factor de ajuste: 0,4
                        else if (evento.motion.yrel>=0 && angb > -80)
                            angb-=evento.motion.yrel*0.4;//factor de ajuste: 0,4
                        anga+=evento.motion.xrel*0.4;//factor de ajuste: 0,4
                        actualizarCam(x,y,z,angb,anga,rad);
                    }
                    break;
                case SDL_QUIT:
                    fin = true;
                    break;
                case SDL_KEYDOWN:
                    switch(evento.key.keysym.sym){
                    case SDLK_ESCAPE:
                        ajustes = true;
                        opt = 1;
                    break;
                    case SDLK_RETURN:
                            if (inicio1){
                                inicio1 = false;
                                nivel1 = true;

                                equis = 0.0;
                                velocidad = 0.0;
                                eyis = 0.0;
                                ezis = 0.0;
                                alturaReal = 1;
                                hl = 1;
                                diferencia;
                                alturaInicial = 2.0;
                                anteriorEzis = 0;
                                angusYoung = 0;
                                nextEzis = 0;
                                diferencia = alturaInicial - alturaReal;
                            }
                            if (inicio2){
                                inicio2 = false;
                                nivel2 = true;
                                equis = 0.0;
                                velocidad = 0.0;
                                eyis = 0.0;
                                ezis = 0.0;
                                alturaReal = 1;
                                hl = 1;
                                diferencia;
                                alturaInicial = 2.0;
                                anteriorEzis = 0;
                                angusYoung = 0;
                                nextEzis = 0;
                                diferencia = alturaInicial - alturaReal;
                            }
                    break;
                    case SDLK_q:
                        fin = true;
                        break;
                    case SDLK_p:
                        pausa = true;
                        break;
                    case SDLK_UP:
                        acelerando = true;
                        if (ajustes){
                            if (opt > 1)
                                opt -= 1;
                        }
                        if ((velocidad*velocidad*velocidad) <= 0.1*gamespeed){
                            velocidad += 0.00175;
                            ruedagiro1 += 5.0;
                            ruedagiro2 += 5.0;
                        }
                        equis += velocidad*velocidad*velocidad;
                        break;

                    case SDLK_DOWN:
                        acelerando = true;
                        if (ajustes){
                            if (opt < 5)
                                opt += 1;
                        }
                        if ((velocidad*velocidad*velocidad) < 0.1*gamespeed){
                            velocidad += 0.00175;
                            ruedagiro1 += 5.0;
                            ruedagiro2 += 5.0;
                        }
                        equis += velocidad*velocidad*velocidad;
                        if (panio < 25)
                            panio += 1.5;
                        break;
                    case SDLK_LEFT:
                        acelerando = true;
                        if (ajustes){
                            if (opt == 1)
                                if (wireframe)
                                    wireframe = false;
                                else wireframe = true;
                            if (opt == 2)
                                if (textures)
                                    textures = false;
                                else textures = true;
                            if (opt == 3)
                                if (luz)
                                    luz = false;
                                else luz = true;
                            if (opt == 4)
                                if (gamespeed == 1)
                                    gamespeed = 2;
                                else gamespeed = 1;
                            if (opt == 5)
                                ajustes = false;
                        }
                        if(angulo<45)
                            angulo += 2.0;
                        if (eyis < 1.5)
                            eyis += 0.1;
                        if ((velocidad*velocidad*velocidad) < 0.1*gamespeed){
                            velocidad += 0.00175;
                            ruedagiro1 += 5.0;
                            ruedagiro2 += 5.0;
                        }
                        equis += velocidad*velocidad*velocidad;
                        break;
                    case SDLK_RIGHT:
                        acelerando = true;
                        if (ajustes){
                            if (opt == 1)
                                if (wireframe)
                                    wireframe = false;
                                else wireframe = true;
                            if (opt == 2)
                                if (textures)
                                    textures = false;
                                else textures = true;
                            if (opt == 3)
                                if (luz)
                                    luz = false;
                                else luz = true;
                            if (opt == 4)
                                if (gamespeed == 1)
                                    gamespeed = 2;
                                else gamespeed = 1;
                            if (opt == 5)
                                ajustes = false;
                        }
                        if(angulo>-45)
                            angulo -= 2.0;
                        if (eyis > -1.5)
                            eyis -= 0.1;
                        if ((velocidad*velocidad*velocidad) < 0.1*gamespeed){
                            velocidad += 0.00175;
                            ruedagiro1 += 5.0;
                            ruedagiro2 += 5.0;
                        }
                        equis += velocidad*velocidad*velocidad;
                        break;
                    case SDLK_s:
                        rad-=.05;//factor de ajuste: 0,05
                        actualizarCam(x,y,z,angb,anga,rad);
                        break;
                    case SDLK_w:
                        if(rad<0)
                            rad+=.05;//factor de ajuste: 0,05
                        actualizarCam(x,y,z,angb,anga,rad);
                        break;
                    }
                    break;
                }
            }
            SDL_GL_SwapBuffers();
            while (pausa)
                 while(SDL_PollEvent(&evento)){
                    switch(evento.type){
                         case SDL_KEYDOWN:
                            switch(evento.key.keysym.sym){
                                case SDLK_p:
                                    pausa = false;
                                    break;
                                case SDLK_q:
                                    fin = true;
                                    pausa = false;
                                    break;
                                case SDLK_ESCAPE:
                                    ajustes = true;
                                    opt = 1;
                                    break;
                            }
                    }

        }
    }while(!fin);
    delete textur;
    return 0;
}
