#pragma once
#ifndef ANGULAR_ROTATION_H
#define ANGULAR_ROTATION_H

#include "ObjetoGrafico.h"

using namespace std;

enum TipoRotacion {
	INICIO, FIN
};

static int rueda = 0;	//mugre


class AngularRotation : public ObjetoGrafico {
	private:
		TipoRotacion tipo;
		float* centro;
	public:
		AngularRotation(TipoRotacion t, float* c) : ObjetoGrafico() { rueda = 0; tipo = t; centro = c; };
	void dibujar(float angulodelante = 0.0, float angulotrasero = 0.0) {
		switch (tipo) {
			case INICIO:
				glPushMatrix();
				glTranslatef(-centro[0],-centro[1],-centro[2]);	
				if (rueda == 0) {
					glRotatef(angulodelante, 0.0, 0.0, 1.0);
					rueda++;
				}
				else if (rueda == 1) {
					glRotatef(angulotrasero, 0.0, 0.0, 1.0);
					rueda--;
				}
				glTranslatef(centro[0], centro[1], centro[2]);
				break;
			case FIN:
				glPopMatrix();
				break;
		}
	};
	~AngularRotation() {};
};

#endif //CARA_H
