#pragma once
#ifndef BACKGROUND_OBJECT_H
#define BACKGROUND_OBJECT_H

#include "Entidad.h"
#include "ObjetoGrafico.h"
#include "Cara.h"
#include "3DLoader.h"
#include "pugixml-1.7/src/pugixml.hpp"
#include "SDL2-2.0.4\include\SDL_opengl.h"

#include <cstdlib>
#include <string>
#include <map>
#include <time.h>

using namespace std;

class BackgroundObject : public Entidad {
	private:
		vector<float*> repeticion;
	public:
		BackgroundObject(string path, string nombreObj) : Entidad() {			
			bool repetir = false;
			float* posInicial = new float[3];
			posInicial[0] = posInicial[1] = posInicial[2] = 0.0;
			repeticion.push_back(posInicial);
			datosObj = *parsearObj(path, nombreObj, repetir);
			if (repetir){
				//Generar posiciones aleatorias, slo existe traslacin horizontal
				srand(time(NULL));
				int cantidad = rand() % 100 + 5;
				for (int i = 0; i < cantidad; i++) {
					// Construir array
					float* ingreso = new float[3];
					ingreso[0] = rand() % 400 - 205;
					ingreso[1] = 0;
					ingreso[2] = rand() % 20 - 11;
					if (abs(ingreso[2]) < 6.0)
						ingreso[2] += 4.0;
					// Ingresar
					repeticion.push_back(ingreso);
				}
			}
		};
		void actualizar() {};
		void dibujar() {
			// Dibujar en todas las posiciones aleatorias
			glPushMatrix();
			glTranslatef(traslacionArray[0], traslacionArray[1], traslacionArray[2]);
			for (vector<float*>::iterator it = repeticion.begin(); it != repeticion.end(); it++) {
				glPushMatrix();
				glTranslatef((*it)[0], (*it)[1], (*it)[2]);
				for (vector<ObjetoGrafico*>::iterator itO = datosObj.begin(); itO != datosObj.end(); itO++) {
					(*itO)->dibujar();
				}
				glPopMatrix();
			}
			glPopMatrix();
		};

		~BackgroundObject() {};
};

#endif
