#pragma once
#ifndef CARA_H
#define CARA_H

#include "ObjetoGrafico.h"

using namespace std;

class Cara : public ObjetoGrafico {
	private:
		float** vertices;
		float** normales;
		float** texturas;
	public:
		Cara(float** vert, float** norm, float** tex) : ObjetoGrafico() {
			vertices = vert;
			normales = norm;
			texturas = tex;
		};
		void dibujar(float angulodelante = 0.0, float angulotrasero = 0.0) {
			// Dibujar cada vrtice con su normal y puntos de textura
			glBegin(GL_TRIANGLES);
			for (int i = 0; i < 3; i++) {
				// Setear normal
				glNormal3f(normales[i][0], normales[i][1], normales[i][2]);
				// Setear textura
				glTexCoord2f(texturas[i][0],texturas[i][1]);
				// Setear vrtices
				glVertex3f(vertices[i][0], vertices[i][1], vertices[i][2]);
			}
			glEnd();
		};
		~Cara() {};
};

#endif //CARA_H
