#pragma once
#ifndef CONJUNTOPARTICULAS_H
#define CONJUNTOPARTICULAS_H

#include "Particulas.h"
#include <ctime>

//La idea de esta clase es dar un wrapper a la clase Particulas
//Para que sea posible hacer varias explosiones a la vez
//De forma facil
//Es un object pool con limitaciones
class ConjuntoParticulas {
private:
	int cantidadObjetos;
	int objetoActual;
	Particulas * particulas;
	bool * habilitadoObjeto;
public:
	ConjuntoParticulas(int CantidadObjetos, Modo modo) {
		cantidadObjetos = CantidadObjetos;
		habilitadoObjeto = new bool[cantidadObjetos];
		particulas = new Particulas[cantidadObjetos];
		for (int i = 0; i < cantidadObjetos; ++i) {
			particulas[i].setModo(modo);
			habilitadoObjeto[i] = false;
		}
		objetoActual = 0;
		//inicializo aca los numeros aleatorios que voy a usar para generar las particulas
		srand(static_cast <unsigned> (time(0)));
	}
	~ConjuntoParticulas() {
		delete[] particulas, cantidadObjetos;
		delete[] habilitadoObjeto, cantidadObjetos;
	}

	//Deshabilita todas las particulas
	//No se van a actualizar ni a dibujar mas
	void disableParticulas() {
		for (int i = 0; i < cantidadObjetos; ++i) {
			habilitadoObjeto[i] = false;
		}
		objetoActual = 0;
	}

	//Habilita una nueva explosion de particulas
	//Si se llego al maximo de objetos, no pone mas
	//(en un principio habia hecho que se sobreescribiera el primero pero eso hace que ande feo
	//con la implementacion de las colisiones)
	void nuevoParticulas(float x, float y, float z) {
		if (objetoActual < cantidadObjetos) {
			particulas[objetoActual].setInicio(x, y, z);
			habilitadoObjeto[objetoActual] = true;
			++objetoActual;
		}
	}

	void step() {
		for (int i = 0; i < cantidadObjetos; ++i) {
			if (habilitadoObjeto[i]) {
				particulas[i].step();
			}
		}
	}

	void dibujar() {
		for (int i = 0; i < cantidadObjetos; ++i) {
			if (habilitadoObjeto[i]) {
				particulas[i].dibujar();
			}
		}
	}
};

#endif //CONJUNTOPARTICULAS_H