#pragma once
#ifndef CONTACT_LISTENER_H
#define CONTACT_LISTENER_H

#include "Entidad.h"

#include <iostream>
#include <vector>

class ContactListener : public b2ContactListener {
private:
	Entidad * moto;
	vector<Entidad*> suscriptores;
public:
	ContactListener(Entidad * moto) : b2ContactListener() {
		this->moto = moto;
	}
	//agrega una entidad a los suscriptores
	void Suscribir(Entidad * suscriptor) {
		suscriptores.push_back(suscriptor);
	}
	//borra todos los suscriptores
	void Desuscribir() {
		suscriptores.clear();
	}
	void BeginContact (b2Contact* contact){
		bool huboContactoSuscriptor = false;
		b2Body * bodyA = contact->GetFixtureA()->GetBody();
		b2Body * bodyB = contact->GetFixtureB()->GetBody();
		for (int i = 0; i < suscriptores.size(); ++i) {
			if (suscriptores[i]->EsMismoCuerpo(bodyA)) {
				suscriptores[i]->notificar(EV_COLISION, bodyB);
				huboContactoSuscriptor = true;
			}
			else if (suscriptores[i]->EsMismoCuerpo(bodyB)) {
				suscriptores[i]->notificar(EV_COLISION, bodyA);
				huboContactoSuscriptor = true;
			}
		} 
		if ((!huboContactoSuscriptor) && ((moto->EsMismoCuerpo(bodyA)) || (moto->EsMismoCuerpo(bodyB)))) {
			b2WorldManifold worldManifold;
			contact->GetWorldManifold(&worldManifold);	
			moto->notificar(EV_COLISION, &worldManifold.points[0]);
		}
	}
	void EndContact (b2Contact* contact){
		/*
		handle end event
		*/
	}
	void PreSolve(b2Contact* contact, const b2Manifold* oldManifold){
		/*
		handle pre
		-
		solve
		event
		*/
	}
	void PostSolve (b2Contact* contact, const b2ContactImpulse* impulse){
		/*
		handle post
		-
		solve event
		*/
	}
};


#endif //CONTACT_LISTENER_H