#pragma once
#ifndef ENTIDAD_H
#define ENTIDAD_H

#include "SDL.h"
#include "SDL_opengl.h"
#include <Box2D\Box2D.h>

#include <vector>
#include <string>
#include <fstream>

#include "terna.h"
#include "ObjetoGrafico.h"
#include "Utils.h"
#include "Evento.h"


using namespace std;

class Entidad {
    protected:
		vector<ObjetoGrafico*> datosObj;
		float* traslacionArray;
        terna traslacion;
		b2BodyDef bodyDef;	//la definicion del cuerpo, creo que es solo un uso asi que la puedo sacar de aca
		b2Body * body;		//la entidad fisica del cuerpo
		terna posicion;		//la posicion inicial bidimensional (x,y) (creo que la uso solo al principio)

		//bandera de reset
		bool reset;
    public:
		Entidad() {
			traslacionArray = new float[3];
			traslacionArray[0] = traslacionArray[1] = traslacionArray[2] = 0;
			traslacion.x = 0;
			traslacion.y = 0;
			traslacion.z = 0;
			posicion.x = 0;
			posicion.y = 0;
			posicion.z = 0;
		}		        

		virtual void actualizar() {
			reset = false;
		}
		virtual void down_key(SDL_Keycode tecla) {}
		virtual void up_key(SDL_Keycode tecla) {}

		//usando esto podes notificar a la entidad de un evento. de ser necesario podriamos agregar parametros
		virtual void notificar(Evento evento, void * arg) {}

        //para indicarle a la entidad que debe volver a su estado inicial en el proximo actualizar()
		virtual void resetNextAct() {
			reset = true;
		}
		virtual void dibujar() {			
		};
        virtual ~Entidad(){
			//si usas el body en la subclase destruirlo, sino no
			for (vector<ObjetoGrafico*>::iterator it = datosObj.begin(); it != datosObj.end(); it++)
				delete (*it);
			datosObj.clear();
		};

		b2Vec2 GetPosition() {
			return body->GetPosition();
		}

		b2Vec2 GetSpeed() {
			return body->GetLinearVelocity();
		}

		//uso esto en el contactListener
		bool EsMismoCuerpo(b2Body* otherBody) {
			return (body == otherBody);
		}
};


#endif // ENTIDAD_H
