#ifndef HUD_H
#define HUD_H

#include <string>

#include "SDL.h"
#include "SDL_opengl.h"
#include "SDL_ttf.h"
#include <gl/GLU.h>

#include "Mundo.h"

using namespace std;

void dibujarString(string texto, int largo, float red, float green, float blue) {

	glDisable(GL_LIGHTING);
	char *texto2 = _strdup(texto.c_str());

	TTF_Font *fuente = TTF_OpenFont("BEBAS___.ttf", 20);
	SDL_Color color = { red, green, blue };
	SDL_Surface *dibujo = TTF_RenderText_Blended(fuente, texto2, color);

	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, 0);

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, dibujo->w, dibujo->h, 0, GL_RGBA, GL_UNSIGNED_BYTE, dibujo->pixels);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	glColor3f(red, green, blue);
	glBegin(GL_QUADS);
	glTexCoord2f(0, 0); glVertex3f(0 - largo / 2, 0 + dibujo->h / 2, 0);
	glTexCoord2f(1, 0); glVertex3f(0 + largo / 2, 0 + dibujo->h / 2, 0);
	glTexCoord2f(1, 1); glVertex3f(0 + largo / 2, 0 - dibujo->h / 2, 0);
	glTexCoord2f(0, 1); glVertex3f(0 - largo / 2, 0 - dibujo->h / 2, 0);
	glEnd();

	glDisable(GL_BLEND);


	glEnable(GL_LIGHTING);
}

void dibujarTexto(SDL_Surface *texto, int x, int y, int w, int h, GLuint texture, int red, int green, int blue) {

	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, texture);

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, texto->w, texto->h, 0, GL_RGBA, GL_UNSIGNED_BYTE, texto->pixels);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	glColor3f(red, green, blue);
	glBegin(GL_QUADS);
	glTexCoord2f(0, 0); glVertex3f(x, y + h, 0);
	glTexCoord2f(1, 0); glVertex3f(x + w, y + h, 0);
	glTexCoord2f(1, 1); glVertex3f(x + w, y, 0);
	glTexCoord2f(0, 1); glVertex3f(x, y, 0);
	glEnd();


	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
}

void dibujarHud(TTF_Font *fuente, SDL_Color colorfuente, GLuint TextureID, char *name, 
				char *puntaje, char* velocidad, char *muertes, bool ayuda, TTF_Font *fuenteAyuda, 
				SDL_Color colorAyuda, bool wireframe, bool *luces, char* juegoVel, bool texturas) {

	SDL_Surface *texto = NULL;

	glDisable(GL_LIGHTING);

	//Cargar la matriz de proyeccion con una proyeccion ortogonal
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-100.0f, 100.0f, -100.0f, 100.0f, -1.0f, 1.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();


	texto = TTF_RenderText_Blended(fuente, " Puntaje :  ", colorfuente);
	dibujarTexto(texto, -80, 80, 15, texto->h, TextureID, colorfuente.r, colorfuente.g, colorfuente.b);
	SDL_FreeSurface(texto);

	texto = TTF_RenderText_Blended(fuente, puntaje, colorfuente);
	dibujarTexto(texto, -65, 80, texto->w, texto->h, TextureID, colorfuente.r, colorfuente.g, colorfuente.b);
	SDL_FreeSurface(texto);

	texto = TTF_RenderText_Blended(fuente, " N ivel :  ", colorfuente);
	dibujarTexto(texto, 0, 80, 10, texto->h, TextureID, colorfuente.r, colorfuente.g, colorfuente.b);
	SDL_FreeSurface(texto);

	texto = TTF_RenderText_Blended(fuente, name, colorfuente);
	dibujarTexto(texto, 10, 80, 10, texto->h, TextureID, colorfuente.r, colorfuente.g, colorfuente.b);
	SDL_FreeSurface(texto);

	texto = TTF_RenderText_Blended(fuente, " Velocidad :  ", colorfuente);
	dibujarTexto(texto, -80, 60, 20, texto->h, TextureID, colorfuente.r, colorfuente.g, colorfuente.b);
	SDL_FreeSurface(texto);

	texto = TTF_RenderText_Blended(fuente, velocidad, colorfuente);
	dibujarTexto(texto, -60, 60, texto->w, texto->h, TextureID, colorfuente.r, colorfuente.g, colorfuente.b);
	SDL_FreeSurface(texto);

	texto = TTF_RenderText_Blended(fuente, " Muertes :  ", colorfuente);
	dibujarTexto(texto, 0, 60, 15, texto->h, TextureID, colorfuente.r, colorfuente.g, colorfuente.b);
	SDL_FreeSurface(texto);

	texto = TTF_RenderText_Blended(fuente, muertes, colorfuente);
	dibujarTexto(texto, 15, 60, texto->w, texto->h, TextureID, colorfuente.r, colorfuente.g, colorfuente.b);
	SDL_FreeSurface(texto);


	if (ayuda) {
		glBegin(GL_QUADS);
		glColor3f(0.0, 0.0, 0.0);
		glVertex3f(-100, -100, -0.5);
		glVertex3f(-100, -70, -0.5);
		glVertex3f(100, -70, -0.5);
		glVertex3f(100, -100, -0.5);
		glEnd();

		if (!wireframe) {
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(-90, -96, -0.4);
			glVertex3f(-90, -85, -0.4);
			glVertex3f(-83, -85, -0.4);
			glVertex3f(-83, -96, -0.4);
			glEnd();
		}
		else {
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(-80, -96, -0.4);
			glVertex3f(-80, -85, -0.4);
			glVertex3f(-71, -85, -0.4);
			glVertex3f(-71, -96, -0.4);
			glEnd();
		}

		if (texturas == true){
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(-40, -96, -0.4);
			glVertex3f(-40, -85, -0.4);
			glVertex3f(-33, -85, -0.4);
			glVertex3f(-33, -96, -0.4);
			glEnd();
		}
		else{
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(-30, -96, -0.4);
			glVertex3f(-30, -85, -0.4);
			glVertex3f(-21, -85, -0.4);
			glVertex3f(-21, -96, -0.4);
			glEnd();
		}

		if (luces[0] == true) {
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(55, -96, -0.3);
			glVertex3f(55, -85, -0.3);
			glVertex3f(57.2, -85, -0.3);
			glVertex3f(57.2, -96, -0.3);
			glEnd();
		}
		if (luces[1] == true) {
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(59.3, -96, -0.3);
			glVertex3f(59.3, -85, -0.3);
			glVertex3f(60.5, -85, -0.3);
			glVertex3f(60.5, -96, -0.3);
			glEnd();
		}
		if (luces[2] == true) {
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(62.5, -96, -0.3);
			glVertex3f(62.5, -85, -0.3);
			glVertex3f(64.5, -85, -0.3);
			glVertex3f(64.5, -96, -0.3);
			glEnd();
		}
		if (luces[3] == true) {
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(66.5, -96, -0.3);
			glVertex3f(66.5, -85, -0.3);
			glVertex3f(68.5, -85, -0.3);
			glVertex3f(68.5, -96, -0.3);
			glEnd();
		}
		if (luces[4] == true) {
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(70.5, -96, -0.3);
			glVertex3f(70.5, -85, -0.3);
			glVertex3f(72.5, -85, -0.3);
			glVertex3f(72.5, -96, -0.3);
			glEnd();
		}
		if (luces[5] == true) {
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(74.5, -96, -0.3);
			glVertex3f(74.5, -85, -0.3);
			glVertex3f(76.5, -85, -0.3);
			glVertex3f(76.5, -96, -0.3);
			glEnd();
		}
		if (luces[6] == true) {
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(78.5, -96, -0.3);
			glVertex3f(78.5, -85, -0.3);
			glVertex3f(80.5, -85, -0.3);
			glVertex3f(80.5, -96, -0.3);
			glEnd();
		}
		if (luces[7] == true) {
			glColor3f(255.0, 0.0, 0.0);
			glBegin(GL_QUADS);
			glVertex3f(82.5, -96, -0.3);
			glVertex3f(82.5, -85, -0.3);
			glVertex3f(84.5, -85, -0.3);
			glVertex3f(84.5, -96, -0.3);
			glEnd();
		}

		glColor3f(255.0, 0.0, 0.0);
		texto = TTF_RenderText_Blended(fuenteAyuda, " Wireframe : W  ", colorAyuda);
		dibujarTexto(texto, -95, -85, 40, texto->h, TextureID, colorAyuda.r, colorAyuda.g, colorAyuda.b);
		SDL_FreeSurface(texto);
		
		texto = TTF_RenderText_Blended(fuenteAyuda, " On / Off  ", colorAyuda);
		dibujarTexto(texto, -90, -97, 20, texto->h, TextureID, colorAyuda.r, colorAyuda.g, colorAyuda.b);
		SDL_FreeSurface(texto);
		
		texto = TTF_RenderText_Blended(fuenteAyuda, " Texturas : T  ", colorAyuda);
		dibujarTexto(texto, -45, -85, 40, texto->h, TextureID, colorAyuda.r, colorAyuda.g, colorAyuda.b);
		SDL_FreeSurface(texto);

		texto = TTF_RenderText_Blended(fuenteAyuda, " On / Off  ", colorAyuda);
		dibujarTexto(texto, -40, -97, 20, texto->h, TextureID, colorAyuda.r, colorAyuda.g, colorAyuda.b);
		SDL_FreeSurface(texto);

		texto = TTF_RenderText_Blended(fuenteAyuda, " Velocidad : +/-  ", colorAyuda);
		dibujarTexto(texto, 05, -85, 40, texto->h, TextureID, colorAyuda.r, colorAyuda.g, colorAyuda.b);
		SDL_FreeSurface(texto);

		texto = TTF_RenderText_Blended(fuenteAyuda, juegoVel, colorAyuda);
		dibujarTexto(texto, 15, -97, 20, texto->h, TextureID, colorAyuda.r, colorAyuda.g, colorAyuda.b);
		SDL_FreeSurface(texto);

		texto = TTF_RenderText_Blended(fuenteAyuda, " Luces :  ", colorAyuda);
		dibujarTexto(texto, 55, -85, 30, texto->h, TextureID, colorAyuda.r, colorAyuda.g, colorAyuda.b);
		SDL_FreeSurface(texto);

		texto = TTF_RenderText_Blended(fuenteAyuda, " 0/1/2/3/4/5/6/7 ", colorAyuda);
		dibujarTexto(texto, 55, -97, 30, texto->h, TextureID, colorAyuda.r, colorAyuda.g, colorAyuda.b);
		SDL_FreeSurface(texto);
		
	}

	glEnable(GL_LIGHTING);

}






















#endif