#pragma once
#ifndef VECT_H
#define VECT_H

#include <math.h>
#include <iostream>

using namespace std;

class vect {
public:
	//las posiciones son miembros publicos, esta clase es poco mas que un wrapper para un struct
	float x, y, z;
	vect() {
		x = y = z = 0.0f;
	}

	vect(float x, float y, float z) : x(x), y(y), z(z) {}

	void setPos(float x, float y, float z) {
		this->x = x;
		this->y = y;
		this->z = z;
	}

	void resetPos() {
		x = y = z = 0.0f;
	}

	float getModulo() {
		return sqrt(x*x + y*y + z*z);
	}
	//el resultado de la operacion se guarda siempre en this

	void sumar (vect v) {	//suma v a this
		x += v.x;
		y += v.y;
		z += v.z;
	}

	void restar (vect v) {
		x -= v.x;
		y -= v.y;
		z -= v.z;
	}

	void multiplicar (float esc) {	//producto escalar
		x *= esc;
		y *= esc;
		z *= esc;
	}

	void multiplicar (vect v) {		//cross product
		x = y*v.z - z*v.y;
		y = z*v.x - x*v.z;
		z = x*v.y - y*v.x;
	}

	float dot_product (vect v) {		//dot product
		return (x * v.x + y * v.y + z * v.z);
	}

	float angulo (vect v) {
		return acos(this->dot_product(v) / (this->getModulo() * v.getModulo()));
	}

	void dividir (float esc) {
		x /= esc;
		y /= esc;
		z /= esc;
	}

	void negar () {
		this->multiplicar(-1);
	}

	void normalizar () {
		this->dividir(this->getModulo());
	}

	void simetrizar (vect v) {

	}
};

#endif
