#ifndef MENU_H
#define MENU_H
#include "Mapa.h"
#include "Moto.h"
#include "TexLoader.h"

struct NumbersM {
    int texID;
    int cero;
    int one;
    int two;
    int three;
    int four;
    int five;
    int six;
    int seven;
    int eight;
    int nine;
};

class Menu
{
    public:
        Menu();
        virtual ~Menu();
        bool init();
        void runInicio(SDL_Window* window, vector<Moto*> motos, int& indice, bool& fin);
        void runPausa(SDL_Window* window, Mapa* mapa, Moto* moto, bool& wireframe, bool& textures, bool& fin, bool& fullscreen);
        void runWasted(SDL_Window* window, bool& wasted, Mapa* mapa, Moto* moto, bool& wireframe, bool& textures, bool& fin, bool& fullscreen, int puntos);
        void setCamara(float x, float y, float z, float motoX, float motoY, float motoZ);

    private:
        void loadNumbersM(float ancho, float altura);
        void writeNumbersM(int points, float x, float y);
        void DrawPausa(int w, int h, bool& wireframe, bool& textures, bool& fin, bool& fullscreen);
        void DrawInicio(int w, int h);
        void DrawWasted(int w, int h, int puntaje);
        void init3d(bool wireframe, bool textures, bool fullscreen);


        Mapa* mapa;
        Moto* moto;

        float x;
        float y;
        float z;
        float motoX;
        float motoY;
        float motoZ;

        TexLoader id_wireframe;
        TexLoader id_texturas;
        TexLoader id_velocidad;
        TexLoader id_fullscreen;
        TexLoader id_numeros;
        TexLoader id_tick;
        TexLoader id_notick;
        TexLoader id_pausa;
        TexLoader id_comenzar;
        TexLoader id_flecha;
        TexLoader id_reintentar;
        TexLoader id_salir;
        TexLoader id_puntaje;
        TexLoader id_wasted;
        NumbersM num;
};



#endif // MENU_H
