#include "HUD.h"
#include "TexLoader.h"
#include <math.h>

HUD::HUD()
{
    //ctor
}

HUD::~HUD()
{
    //dtor
}

HUD::Load() {
    idHUD=glGenLists(1);
    glNewList(idHUD,GL_COMPILE);
    glBegin(GL_POLYGON);
        for(int ii = 0; ii < 200; ii++)
        {
            glNormal3f(0,0, 1);
            float theta = 2.0f * M_PI * float(ii) / float(200);//get the current angle
            float tu = 0.5 * cosf(theta);
            float tv = 0.5 * sinf(theta);
            float x = 50 * cosf(theta);//calculate the x component
            float y = 50 * sinf(theta);//calculate the y component
            glColor3f(1.0,1.0,1.0);
            glTexCoord2f(tu + 0.5, tv + 0.5);
            glVertex3f(x, y, 0);//output vertex
        }
    glEnd();
    glEndList();

    idAguja=glGenLists(1);
    glNewList(idAguja, GL_COMPILE);
    glBegin(GL_QUADS);
        glColor3f(1.0,1.0,1.0);
        glVertex3f(0, 0, 0);
        glColor3f(1.0,1.0,1.0);
        glVertex3f(-3, 3, 0);
        glColor3f(1.0,1.0,1.0);
        glVertex3f(-40, 0, 0);
        glColor3f(1.0,1.0,1.0);
        glVertex3f(-3, -3, 0);
    glEnd();
    glEndList();

    anguloAguja = 45;

    int r = 50;

    idPuntaje=glGenLists(1);
    glNewList(idPuntaje, GL_COMPILE);
    glBegin(GL_QUADS);
        glColor3f(1.0,1.0,1.0);
        glTexCoord2f(0, 0);
        glVertex3f(r + 0, 0, 0);
        glTexCoord2f(0, 1);
        glVertex3f(r + 0, 30, 0);
        glTexCoord2f(1, 1);
        glVertex3f(r + 100, 30, 0);
        glTexCoord2f(1, 0);
        glVertex3f(r + 100, 0, 0);
    glEnd();
    glEndList();

    idNivel=glGenLists(1);
    glNewList(idNivel, GL_COMPILE);
    glBegin(GL_QUADS);
        glColor3f(1.0,1.0,1.0);
        glTexCoord2f(0, 0);
        glVertex3f(r + 0, -30, 0);
        glTexCoord2f(0, 1);
        glVertex3f(r + 0, 0, 0);
        glTexCoord2f(1, 1);
        glVertex3f(r + 100, 0, 0);
        glTexCoord2f(1, 0);
        glVertex3f(r + 100, -30, 0);
    glEnd();
    glEndList();

    loadNumbers(15,28);

    TexLoader textura;
	textura.Load("Texturas/velocimeter.png", GL_RGB);
	texIdHUD = textura.GetID();

	textura.Load("Texturas/puntaje.png", GL_RGBA);
	texIdPuntaje = textura.GetID();

	textura.Load("Texturas/nivel.png", GL_RGBA);
	texIdNivel = textura.GetID();

	points = 0;
	level = 1;
}

HUD::Draw(float velocidad, int puntos) {

    glTranslatef(60,60,0);

    //Draw Tablero
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glBegin(GL_QUADS);
        glColor4f(0.0,0.0,0.0,0.5);
        glVertex3f(0, 30, 0);
        glVertex3f(0, -30, 0);
        glVertex3f(250, -30, 0);
        glVertex3f(250, 30, 0);
    glEnd();


    glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,texIdPuntaje);
    glCallList(idPuntaje);
    glDisable(GL_TEXTURE_2D);

    points = puntos;
    writeNumbers(points, 150, 0);

    glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,texIdNivel);
    glCallList(idNivel);
    glDisable(GL_TEXTURE_2D);

    writeNumbers(level, 150, -30);

    glDisable(GL_BLEND);
    glColor4f(1,1,1,1);

    //Draw Speedometer
    glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,texIdHUD);
    glCallList(idHUD);
    glDisable(GL_TEXTURE_2D);

    //Draw Pointer
    if (velocidad == 1 && anguloAguja > -225)
        anguloAguja -= 5;
    else if (velocidad == 0 && anguloAguja < 45)
        anguloAguja += 1;
    glRotatef(anguloAguja,0,0,1);
    glCallList(idAguja);


}

void HUD::nextLevel() {
    level++;
}

void HUD::loadNumbers(float ancho, float altura) {
    glColor3f(1.0,1.0,1.0);

    float width = 1.0/11.0;
    float tu = 0;
    float tv = 0;

    for ( int i = 0; i < 10; i++) {
        int id=glGenLists(1);
        glNewList(id, GL_COMPILE);

        glBegin(GL_QUADS);
            glTexCoord2f(tu, 0);
            glVertex3f(0, 0, 0);
            glTexCoord2f(tu, 1);
            glVertex3f(0, altura, 0);
            glTexCoord2f(tu+width, 1);
            glVertex3f(ancho, altura, 0);
            glTexCoord2f(tu+width, 0);
            glVertex3f(ancho, 0, 0);
        glEnd();
        glEndList();

        tu = tu + width;

        switch ( i ) {
            case 0 : num.cero = id; break;
            case 1 : num.one = id; break;
            case 2 : num.two = id; break;
            case 3 : num.three = id; break;
            case 4 : num.four = id; break;
            case 5 : num.five = id; break;
            case 6 : num.six = id; break;
            case 7 : num.seven = id; break;
            case 8 : num.eight = id; break;
            case 9 : num.nine = id; break;
        }
    }

    TexLoader textura;
	textura.Load("Texturas/numeros.png", GL_RGBA);
	num.texID = textura.GetID();
}

void HUD::writeNumbers(int points, float x, float y) {
    float ancho = 13.5;

    glPushMatrix();
        glTranslatef(x, y, 0);
        glEnable(GL_TEXTURE_2D);
        glBindTexture(GL_TEXTURE_2D,num.texID);

        int * digitos = new int[10];
        int i = 0;
        while (points > 0) {
            int resto = points % 10;
            points = points / 10;

            digitos[i] = resto;
            i++;
        }

        if (i == 0)
            digitos[i] = 0;
        else
            i--;

        while ( i >= 0) {
            switch ( digitos[i] ) {
                case 0 : glCallList(num.cero); break;
                case 1 : glCallList(num.one); break;
                case 2 : glCallList(num.two); break;
                case 3 : glCallList(num.three); break;
                case 4 : glCallList(num.four); break;
                case 5 : glCallList(num.five); break;
                case 6 : glCallList(num.six); break;
                case 7 : glCallList(num.seven); break;
                case 8 : glCallList(num.eight); break;
                case 9 : glCallList(num.nine); break;
            }

            glTranslatef(ancho, 0, 0);

            i--;
        }

        glDisable(GL_TEXTURE_2D);
    glPopMatrix();
}
