#include "Moto.h"
#include "ObjLoader.h"
#define g 9.8
#define friction 0.8
#define frictionAir 0.07
#include <iostream>
#define radio_smoke 0.125
#define dTime 0.016

Moto::Moto()
{
    //ctor
}

Moto::~Moto()
{
    //dtor
}

void Moto::Load(int modelo){
    ObjLoader objL;
    switch(modelo){
    case 1:
        objL.loadObj("Modelos/moto2.obj", id_Moto);
        rueda.Load(modelo);
        ruedaT.x= 0.66;
        ruedaT.y= 0.2;
        ruedaD.x= 0.6;
        ruedaD.y= 0.2;
        WHEEL_RADIO= 0.21;
        cEscape.x= -0.15-radio_smoke;
        cEscape.y= -0.04;
        cEscape.z= 0.09;
        break;
    case 2:
        objL.loadObj("Modelos/moto3.obj", id_Moto);
        rueda.Load(modelo);
        ruedaT.x= 0.63;
        ruedaT.y= 0.25;
        ruedaD.x= 0.67;
        ruedaD.y= 0.25;
        WHEEL_RADIO= 0.23;
        cEscape.x= -radio_smoke-0.05;
        cEscape.y= 0.47;
        cEscape.z= 0.04;
        break;
    case 3:
        objL.loadObj("Modelos/moto4.obj", id_Moto);
        rueda.Load(modelo);
        ruedaT.x= 0.67;
        ruedaT.y= 0.25;
        ruedaD.x= 0.7;
        ruedaD.y= 0.25;
        WHEEL_RADIO= 0.29;
        cEscape.x= 0.08-radio_smoke;
        cEscape.y= 0.02;
        cEscape.z= 0.2;
        break;
    }
    velocidad={0,0};
    back_wheel= {-ruedaT.x, 0.0};
    front_wheel= {ruedaD.x, 0.0};
    posicion= {0.0, ruedaT.y + WHEEL_RADIO};
    inclinacion= 0;
    wheel_rotation= 0;
    free_fall = false;
    inc_aux= 0;
    velocidadGiro= 0;
    inclinacion_deg= 0;
    avance= 0;
    cEsc.init();
    flip= 0;
    humoOn= false;

    for (int i = 0; i<300; i++)
        camino.push_back(0.0);
}

void Moto::setMapa(Mapa* mapita){
    mapa= mapita;
}


void Moto::mover(float acceleration, float incline, float& x, float& y,float gameS, float delta_t, bool& dead, bool& win, int& points){

    delta_t= dTime*gameS;
    if (!dead){
        if(!free_fall){
            inc_aux = 0;
            glm::vec2 normal;
            glm::vec2 aceleracion;

            float acc_normal=g*cos(inclinacion);

            //se descompone la normal
            normal.x = -sin(inclinacion)*acc_normal;
            normal.y = cos(inclinacion)*acc_normal;


            //se descompone la aceleracion y se suman las demas aceleraciones para conseguir el total
            aceleracion.x = acceleration*cos(inclinacion)+normal.x;
            aceleracion.y = acceleration*sin(inclinacion)-g+normal.y;

            //se calculan las velocidades en x y y
            velocidad.x += (aceleracion.x-friction*velocidad.x)*delta_t;
            velocidad.y += (aceleracion.y-friction*velocidad.y)*delta_t;

        }else{
            velocidadGiro+= incline-velocidadGiro*frictionAir;
            if(velocidadGiro > 13)
                velocidadGiro= 13;
            else if(velocidadGiro < -10)
                velocidadGiro= -10;
            velocidad.y+=(-g)*delta_t;
            if (inc_aux > 360)
                inc_aux-=360;
            if (inc_aux < -360)
                inc_aux+=360;
            inc_aux += velocidadGiro;
            flip+= velocidadGiro*delta_t;
        }



        //se calcula la posicion del centro de la moto
        posicion.x+=velocidad.x*delta_t;
        posicion.y+=velocidad.y*delta_t;


        back_wheel.y+=velocidad.y*delta_t;
        front_wheel.y+=velocidad.y*delta_t;



       //Calculo la altura del piso en el x donde estan las ruedas

        float realxT=cos(inclinacion)*ruedaT.x;
        float realxD=cos(inclinacion)*ruedaD.x;

        back_wheel.x = posicion.x-realxT;
        float y_back = mapa->getAltura(back_wheel.x); //getHeight(back_wheel.x);


        front_wheel.x = posicion.x+realxD;
        float y_front= mapa->getAltura(front_wheel.x); //getHeight(front_wheel.x);

        //Chequeo si la moto esta tocando el suelo
        if(y_back > back_wheel.y){
            back_wheel.y = y_back;
            free_fall=false;
            velocidadGiro= 0;
            if(flip!=0){
                points+= (((abs((int)flip))/180)*515);
                flip= 0;
            }
            //modelo de la colision
            if (((inc_aux > 95)&&(inc_aux< 265))||((inc_aux<-95))&&(inc_aux > -265)){
                dead = true;
            }
        }else{
            free_fall=true;
        }
        if(y_front > front_wheel.y)
            front_wheel.y = y_front;

        //calculo la inclinacion de las ruedas
        glm::vec2 vec_inclinacion;
        vec_inclinacion = front_wheel-back_wheel;

       /* if (inclinacion > 2*M_PI)
            inclinacion-=2*M_PI;
        if (inclinacion < -2*M_PI)
            inclinacion+=2*M_PI;*/
        inclinacion= atan2(vec_inclinacion.y, vec_inclinacion.x);

        if (wheel_rotation > 360)
            wheel_rotation-=360;
        if (wheel_rotation < -360)
            wheel_rotation+=360;

        wheel_rotation -= (velocidad.x) / WHEEL_RADIO;
    }
    inclinacion_deg = inclinacion*(180/M_PI);

    x = posicion.x;
    y = back_wheel.y;

    if((int)x>avance){
        points+=5;
        avance= (int)x;
    }

    //Tiro humo
    if(acceleration!=0)
        cEsc.brum((back_wheel.x+cEscape.x)/**cos(inclinacion)*/,(back_wheel.y+WHEEL_RADIO+cEscape.y)/*/cos(inclinacion)*/, cEscape.z);

    camino.push_back(back_wheel.x);
    camino.push_back(back_wheel.y + WHEEL_RADIO);
    camino.erase(camino.begin());
    camino.erase(camino.begin());

    win = mapa->levelOver(back_wheel.x);
}

void Moto::Draw(){
    //Parte de dibujar
        glEnable(GL_LINE_STIPPLE);
        glLineStipple(4, 0xAAAA);
        glBegin(GL_LINE_STRIP);
        vector<float>::iterator it = camino.begin();
        while (it != camino.end()) {
            glVertex2f(*(it), *(it+1));
            it = it+2;
        }
        glEnd();
        glDisable(GL_LINE_STIPPLE);

        glPushMatrix();
        glTranslatef(posicion.x, WHEEL_RADIO +ruedaT.y +back_wheel.y, 0.0);
        glRotatef(inc_aux, 0.0, 0.0, 1.0);
        glTranslatef(-ruedaT.x,0.0,0.0);
        glRotatef(inclinacion_deg, 0.0, 0.0, 1.0);
        glTranslatef(ruedaT.x,0.0,0.0);
        glCallList(id_Moto);

        glPushMatrix();
            glTranslatef(-ruedaT.x,-ruedaT.y,0.0);
            glRotatef(wheel_rotation, 0.0, 0.0, 1.0);
            rueda.Draw();
        glPopMatrix();

        glPushMatrix();
            glTranslatef(ruedaD.x,-ruedaD.y,0.0);
            glRotatef(wheel_rotation, 0.0, 0.0, 1.0);
            rueda.Draw();
        glPopMatrix();
    glPopMatrix();
    glColor4f(1, 1, 1, 1);
    glBindTexture(GL_TEXTURE_2D, 0);

    if(humoOn)
        cEsc.Draw();
}

void Moto::switchHumo(){
    humoOn= !humoOn;
}

void Moto::switchBillboard(){
    cEsc.switchBillboard();
}

void Moto::restart(){
    posicion.x=0; posicion.y =0;
    back_wheel.x =0; back_wheel.y =0;
    front_wheel.x=0; front_wheel.y=0;
    velocidad.x=0; velocidad.y=0;
    inclinacion=0;
    velocidadGiro= 0;
    avance= 0;
}
