#include "Skybox.h"
#include "ObjLoader.h"
#define zfar 100

Skybox::Skybox(){
    id_Skybox=0;
    id_Mountain=0;
}

Skybox::~Skybox()
{
    //dtor
}

void Skybox::Load(int nivel){
	float dist = zfar*cos(45.0f); //zfar a secas era la distancia del jugador a una de las esquinas de la hitbox
	float th = 1.0f/3.0f; // un tercio en coordenadas de textura
	float of = (1.0f/1024.0f)/2; //offset de ~1/2 texel
    ObjLoader objL;
    objL.loadObj("Mapas/mountain.obj", id_Mountain);
    TexLoader textura;
    textura.Load("Texturas/skybox1.jpg", GL_RGB);
    skyboxarray[0]=textura.GetID();
    textura.Load("Texturas/skyboxdawn.jpg", GL_RGB);
    skyboxarray[1]=textura.GetID();
    textura.Load("Texturas/skyboxnight2.jpg", GL_RGB);
    skyboxarray[2]=textura.GetID();
    glBindTexture(GL_TEXTURE_2D, 0);


	id_Skybox=glGenLists(1);
	glNewList(id_Skybox,GL_COMPILE);
        // Top
        glBegin(GL_QUADS);
            glTexCoord2f(0.25f+of, 1*th-of); glVertex3f(dist, dist,  dist);
            glTexCoord2f(0.50f-of, 1*th-of); glVertex3f(-dist, dist,  dist);
            glTexCoord2f(0.50f-of, 0.0f+of); glVertex3f(-dist, dist,  -dist);
            glTexCoord2f(0.25f+of, 0.0f+of); glVertex3f(dist, dist,  -dist);
        glEnd();
        // Bottom
        glBegin(GL_QUADS);
            glTexCoord2f(0.25f+of, 1.0f-of); glVertex3f(dist, -dist,  -dist);
            glTexCoord2f(0.50f-of, 1.0f-of); glVertex3f(-dist, -dist,  -dist);
            glTexCoord2f(0.50f-of, 2*th+of); glVertex3f(-dist, -dist,  dist);
            glTexCoord2f(0.25f+of, 2*th+of); glVertex3f(dist, -dist,  dist);
        glEnd();

        // Front
        glBegin(GL_QUADS);
            glTexCoord2f(0.25f, 2*th-of); glVertex3f(dist, -dist,  dist);
            glTexCoord2f(0.50f, 2*th-of); glVertex3f(-dist, -dist,  dist);
            glTexCoord2f(0.50f, 1*th+of); glVertex3f(-dist, dist,  dist);
            glTexCoord2f(0.25f, 1*th+of); glVertex3f(dist, dist,  dist);
        glEnd();
        // Back
        glBegin(GL_QUADS);
            glTexCoord2f(0.75f, 2*th-of); glVertex3f(-dist, -dist,  -dist);
            glTexCoord2f(1.00f, 2*th-of); glVertex3f(dist, -dist,  -dist);
            glTexCoord2f(1.00f, 1*th+of); glVertex3f(dist, dist,  -dist);
            glTexCoord2f(0.75f, 1*th+of); glVertex3f(-dist, dist,  -dist);
        glEnd();

        // Right
        glBegin(GL_QUADS);
            glTexCoord2f(0.50f, 2*th-of); glVertex3f(-dist, -dist,  dist);
            glTexCoord2f(0.75f, 2*th-of); glVertex3f(-dist, -dist,  -dist);
            glTexCoord2f(0.75f, 1*th+of); glVertex3f(-dist, dist,  -dist);
            glTexCoord2f(0.50f, 1*th+of); glVertex3f(-dist, dist,  dist);
        glEnd();
        // Left
        glBegin(GL_QUADS);
            glTexCoord2f(0.00f, 2*th-of); glVertex3f(dist, -dist,  -dist);
            glTexCoord2f(0.25f, 2*th-of); glVertex3f(dist, -dist,  dist);
            glTexCoord2f(0.25f, 1*th+of); glVertex3f(dist, dist,  dist);
            glTexCoord2f(0.00f, 1*th+of); glVertex3f(dist, dist,  -dist);
        glEnd();

	glEndList();
}


void Skybox::Draw(float cam_x,float cam_y,float cam_z, int sky){
    glDisable(GL_LIGHTING);
    glDisable(GL_DEPTH_TEST); //desactivo el depth test para que el jugador no vea como el skymap corta con el escenario
	glPushMatrix();
        glBindTexture(GL_TEXTURE_2D, skyboxarray[sky]);
        glTranslatef(cam_x,cam_y,cam_z);
        glCallList(id_Skybox);
	glPopMatrix();
	glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glPushMatrix();
        glTranslatef(cam_x,0.0,cam_z);
        glRotatef(-90, 0.0,1.0,0.0);
        glTranslatef(-zfar+50, -1.0, 0.0);
        glCallList(id_Mountain);
	glPopMatrix();
}
