#include "Terreno.h"
#include <math.h>
#include "ObjLoader.h"
#include "SDL2/SDL_opengl.h"

Terreno::Terreno()
{
    //ctor
}

Terreno::~Terreno()
{
    //dtor
}

Pista::Pista(int id, float ini, int idMod){
    ident = id;
    inicio = ini;
    switch (id){
    case 1:{
        fin = ini+7.74;
        idModelo = idMod;
        break;
    }
    case 2:{
        fin = ini+9.79;
        idModelo = idMod;
        break;
    }
    case 3:{
        fin = ini+8.61;
        idModelo = idMod;
        break;
    }
    }
}

float Pista::getAltura(float x){
    switch (ident){
        case 1:{
            float m1=tan(M_PI/4);
            return m1*(x-inicio);
            break;
        }

        case 2:{
            float m=tan((5*M_PI/6));
                if(x<6+inicio)
                    return 2.09;
                else
                    return m*(x-inicio-6)+2.19;
            break;
        }
        case 3:{
            if(x<=6.02+inicio)
                return (exp((x-inicio)-3)-0.05)/(x-inicio);
            if(x<7.02+inicio)
                return sin((x-inicio)*2+2)+2.4;
            return -(x-inicio)*1.3+11.2;
            break;
        }
    }
}

void Terreno::addPista(int id, float pos,int idMod){
    pistas.push_back(new Pista(id, pos,idMod));
}

void Terreno::addFinish(float f ){
    finishLine = f;
}

bool Terreno::LevelOver(float x){
    if (x > finishLine){
            for(int i = 0; i < pistas.size(); i++){
                delete pistas[i];
                pistas.pop_back();
            }
    }
    return x > finishLine;
}


bool Terreno::Load(int nivel){
    ObjLoader objL;
    bool ok;

    switch(nivel){
    case 1:{
        objL.loadObj("Mapas/platform45.obj", idpista1);
        objL.loadObj("Mapas/pista2_1.obj", idpista2);
        objL.loadObj("Mapas/pista3.obj", idpista3);
        objL.loadObj("Mapas/floor.obj", idFloor);
        objL.loadObj("Mapas/finishLine.obj", idFinishLine);
        addPista(1, 0.0, idpista1);
        addPista(2, 20.0, idpista2);
        addPista(3, 30.0, idpista3);
        addFinish(60);
        break;
    }
    case 2:{
        addPista(3, 1.0,  idpista3);
        addPista(1, 20.0, idpista1);
        addPista(1, 40.0, idpista1);
        addPista(2, 55.0, idpista2);
        addPista(1, 80.0, idpista1);
        addFinish(100);
        break;
    }
    }
    return ok;
}


float Terreno::getAltura(float x){
    for(int i = 0; i < pistas.size(); i++){
        if((pistas[i]->inicio<x)&& (pistas[i]->fin>x))
            return pistas[i]->getAltura(x);
    }
    return 0.0;
}

void Terreno::Draw(){
    glPushMatrix();
        glCallList(idFloor);
        for(int i = 0; i < pistas.size(); i++){
            glPushMatrix();
                glTranslatef(pistas[i]->inicio, 0.0,0.0);
                glCallList(pistas[i]->idModelo);
            glPopMatrix();
        }
        glPushMatrix();
            glTranslatef(finishLine, 0.0,0.0);
            glCallList(idFinishLine);
        glPopMatrix();


    glPopMatrix();
}
