#include "TexLoader.h"
#include "FreeImage/FreeImage.h"

TexLoader::TexLoader(){
    id= 0;
    width= 0;
    height= 0;
}

TexLoader::~TexLoader(){
    id= 0;
    width= 0;
    height= 0;
}


bool TexLoader::Load(char *archivo,int type){


    FREE_IMAGE_FORMAT fif = FreeImage_GetFIFFromFilename(archivo);
    FIBITMAP* bitmap = FreeImage_Load(fif, archivo);
    if(type == GL_RGB)
        bitmap = FreeImage_ConvertTo24Bits(bitmap);

    width = FreeImage_GetWidth(bitmap);
    height = FreeImage_GetHeight(bitmap);

    void* datos = FreeImage_GetBits(bitmap);

    glGenTextures(1, &id);
	glBindTexture(GL_TEXTURE_2D,id);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);


    int components,mode;
	if(type==GL_RGB)	{
		components = 3;
		mode = GL_BGR;
	} else if(type==GL_RGBA){
		components = 4;
		mode = GL_BGRA;
	} else return false;


	//if(!mipmap)	{
		glTexImage2D(GL_TEXTURE_2D,0,components,width,height,0,mode, GL_UNSIGNED_BYTE,datos);
		//gluBuild2DMipmaps(GL_TEXTURE_2D,components,width,height,GL_BGR, GL_UNSIGNED_BYTE,datos);
	/*}
	else
	{
		gluBuild2DMipmaps(GL_TEXTURE_2D,components,width,height,type,
						  GL_UNSIGNED_BYTE,datos);
	}*/
    delete datos;
	return true;
}
int TexLoader::GetID(){
	return id;
}
void TexLoader::GetSize(int *w,int *h){
	*w = width;
	*h = height;
}
