#include "humo.h"
#define despl 0.002
#define despl2 0.0005
#define life_span 80
#include <stdlib.h>

humo::humo(float _x, float _y, float _z, int id, bool bill)
{
    x= _x;
    y= _y;
    z= _z;
    id_humo= id;
    frame = 0;
    diametro= 0.1;
    radio= 0.05;
    billboard= bill;
}

humo::~humo()
{
    //dtor
}


void humo::Draw(){


    glPushMatrix();
        glTranslatef(x,y,z);
        if(billboard){
            glGetFloatv(GL_MODELVIEW_MATRIX , modelview);
            for(int i=0; i<3; i++ ){
                for(int j=0; j<3; j++ ){
                    if ( i==j )
                        modelview[i*4+j] = 1.0;
                    else
                        modelview[i*4+j] = 0.0;
                }
            }
            glLoadMatrixf(modelview);
        }
        if(frame<20){
            glBegin(GL_QUADS);
                glTexCoord2d(0,0);
                glVertex3f(0,0,0);
                glTexCoord2d(0.25,0);
                glVertex3f(diametro,0,0);
                glTexCoord2d(0.25,1);
                glVertex3f(diametro,diametro,0);
                glTexCoord2d(0,1);
                glVertex3f(0,diametro,0);
            glEnd();
        }
        else if(frame < 40){
            glBegin(GL_QUADS);
                glTexCoord2d(0.25,0);
                glVertex3f(0,0,0);
                glTexCoord2d(0.5,0);
                glVertex3f(diametro,0,0);
                glTexCoord2d(0.5,1);
                glVertex3f(diametro,diametro,0);
                glTexCoord2d(0.25,1);
                glVertex3f(0,diametro,0);
            glEnd();
        }
        else if(frame < 60){
            glBegin(GL_QUADS);
                glTexCoord2d(0.5,0);
                glVertex3f(0,0,0);
                glTexCoord2d(0.75,0);
                glVertex3f(diametro,0,0);
                glTexCoord2d(0.75,1);
                glVertex3f(diametro,diametro,0);
                glTexCoord2d(0.5,1);
                glVertex3f(0,diametro,0);
            glEnd();
        }
        else if(frame < life_span){
            glBegin(GL_QUADS);
                glTexCoord2d(0.75,0);
                glVertex3f(0,0,0);
                glTexCoord2d(1,0);
                glVertex3f(diametro,0,0);
                glTexCoord2d(1,1);
                glVertex3f(diametro,diametro,0);
                glTexCoord2d(0.75,1);
                glVertex3f(0,diametro,0);
            glEnd();
        }
    glPopMatrix();

    frame++;
    diametro+= 0.0018;
    x+= despl*(rand()%20);
    y+= despl*(rand()%20);
    z+= despl*(rand()%10);
}


bool humo::isAlive(){
    return frame<life_span;
}







